unit MyCursors;

interface

	uses
		MacOS;

	procedure StartupCursors;
	procedure CursorSet (c: Cursor);
	procedure CursorSetArrow;
	procedure CursorSetIBeam;
	procedure CursorSetCross;
	procedure CursorSetPlus;
	procedure CursorSetWatch;
	
	procedure CursorSetProcessing (processing: Boolean); // Defunct
	procedure SetEnableCursorTask( enable: Boolean ); // Defunct

implementation

	uses
		MyTypes, MySystemGlobals, MyStartup;

{$ifc do_debug}
	var
		startup_check: integer;
{$endc}

	var
		ibeam, cross, plus, watch: Cursor;
		current_cursor: Cursor;
		gCursorTaskProc:UniversalProcPtr;

	procedure UpdateCursor;
	begin
		if in_foreground then begin
			SetCursor(current_cursor);
		end;
	end;

	procedure CursorSet (c: Cursor);
	begin
		current_cursor := c;
		UpdateCursor;
	end;

	procedure CursorSetArrow;
	begin
		CursorSet(GetQDGlobals^.arrow);
	end;

	procedure CursorSetIBeam;
	begin
		CursorSet(ibeam);
	end;

	procedure CursorSetCross;
	begin
		CursorSet(cross);
	end;

	procedure CursorSetPlus;
	begin
		CursorSet(plus);
	end;

	procedure CursorSetWatch;
	begin
		CursorSet(watch);
	end;

	procedure CursorSetProcessing (processing: Boolean);
	begin
		UpdateCursor;
	end;

	function CursorAlert (alertID: integer; filterProc: ModalFilterUPP): integer;
	begin
		CursorSetArrow;
		CursorAlert := Alert(alertID, filterProc);
	end;

	function CursorCautionAlert (alertID: integer; filterProc: ModalFilterUPP): integer;
	begin
		CursorSetArrow;
		CursorCautionAlert := CautionAlert(alertID, filterProc);
	end;

	function CursorNoteAlert (alertID: integer; filterProc: ModalFilterUPP): integer;
	begin
		CursorSetArrow;
		CursorNoteAlert := NoteAlert(alertID, filterProc);
	end;

	function CursorStopAlert (alertID: integer; filterProc: ModalFilterUPP): integer;
	begin
		CursorSetArrow;
		CursorStopAlert := StopAlert(alertID, filterProc);
	end;

	procedure SetEnableCursorTask( enable: Boolean );
	begin
	end;

	function InitCursors(var msg: integer): OSStatus;
	begin
{$unused(msg)}
		DidStartup( startup_check );
		ibeam := GetCursor(iBeamCursor)^^;
		cross := GetCursor(crossCursor)^^;
		plus := GetCursor(plusCursor)^^;
		watch := GetCursor(watchCursor)^^;
		current_cursor := GetQDGlobals^.arrow;
		CursorSetWatch;
		InitCursors := noErr;
	end;

	procedure StartupCursors;
	begin
//		StartupTimeManager;
		SetStartup(InitCursors, nil, 0, nil);
	end;

end.