unit MyDialogs;

interface

	uses
		MyUtils, MyAssertions;

	const
		i_ok = 1;
		i_cancel = 2;
		i_discard = 3;

	var
		grey_colour: RGBColor;
		grey_pattern: PixPatHandle;

	var
		shutup_talking_alerts: Boolean;
		gShutupTalkingAlertsModalFilterProc:UniversalProcPtr;
		gStandardModalFilterProc:UniversalProcPtr;
		gCancelModalFilterProc:UniversalProcPtr;
		gDiscardModalFilterProc:UniversalProcPtr;
		gOutlineDefault1Proc:UniversalProcPtr;
		gDrawEditTextOutlineProc: UniversalProcPtr;

{$ifc not do_debug}
{$definec AssertValidDialogItem(w,i)}
{$definec AssertValidDialogControl(w,i)}
{$definec AssertValidDialogTextItem(w,i)}
{$definec AssertValidDialogUserItem(w,i)}
{$elsec}
{$definec AssertValidDialogItem(w,i) AssertValidDialogItemCode(w,i)}
{$definec AssertValidDialogControl(w,i) AssertValidDialogControlCode(w,i)}
{$definec AssertValidDialogTextItem(w,i) AssertValidDialogTextItemCode(w,i)}
{$definec AssertValidDialogUserItem(w,i) AssertValidDialogUserItemCode(w,i)}
{$endc}

{$ifc do_debug}
	procedure AssertValidDialogItemCode( window: DialogPtr; item: integer );
	procedure AssertValidDialogControlCode( window: DialogPtr; item: integer );
	procedure AssertValidDialogTextItemCode( window: DialogPtr; item: integer );
	procedure AssertValidDialogUserItemCode( window: DialogPtr; item: integer );
{$endc}

	procedure StartupDialogs;
	procedure SetMyDialogFont(ft:MyFontType);
	procedure ValidDItem( window: WindowPtr; item: integer );
	procedure InvalDItem( window: WindowPtr; item: integer );
	procedure SetItemText (window: DialogPtr; item: integer; text: Str255);
	procedure GetItemText (window: DialogPtr; item: integer; var text: Str255);
	function GetItemTextF (window: DialogPtr; item: integer): Str255;
	procedure EraseDefault1(window: DialogPtr; item: integer);
	procedure OutlineDefault1ForeBackground (window: DialogPtr; item: integer; foreground: Boolean);
	procedure OutlineDefault1 (window: DialogPtr; item: integer);
	procedure SetUpDefaultOutline(window: DialogPtr; def_item, user_item: integer; sethandler: Boolean);
	procedure FlashDItem (window: DialogPtr; item: integer);
	procedure SetDItemRect (window: DialogPtr; item: integer; rr: Rect);
	procedure GetDItemRect (window: DialogPtr; item: integer; var rr: Rect);
//	procedure SetDItemKind (window: DialogPtr; item: integer; k: integer);
// Not appearance happy
	procedure GetDItemKind (window: DialogPtr; item: integer; var k: integer);
	function GetDItemKindF (window: DialogPtr; item: integer): integer;
	function IsControlDialogKind( kind: integer ): Boolean;
	procedure SetDControlRect( window: DialogPtr; item: integer; const frame: Rect );
	function IsDialogItemHidden( window: WindowPtr; item: integer ): Boolean;
	procedure OffsetDItem( window: DialogPtr; item: integer; dh, dv: integer );
	function GetDControlHandle (window: DialogPtr; item: integer): ControlHandle;
//	function GetDItemHandle (window: DialogPtr; item: integer): Handle;
{	procedure SetDItemHandle (window: DialogPtr; item: integer; h: univ Handle);}
// Not appearance happy
	procedure SetUserItemProc (window: DialogPtr; item: integer; proc: UniversalProcPtr);
	function GetDControlEnable (window: DialogPtr; item: integer): Boolean;
	procedure SetDControlEnable (window: DialogPtr; item: integer; on: Boolean);
	function GetDControlTitle (window: DialogPtr; item: integer): Str255;
	procedure SetDControlTitle (window: DialogPtr; item: integer; s: Str255);
	function GetDControlBoolean (window: DialogPtr; item: integer): Boolean;
	procedure SetDControlBoolean (window: DialogPtr; item: integer; value: Boolean);
	procedure ToggleDControlBoolean (window: DialogPtr; item: integer);
	function GetDControlValue (window: DialogPtr; item: integer): integer;
	procedure SetDControlValue (window: DialogPtr; item: integer; value: integer);
	function GetDControlMax (window: DialogPtr; item: integer): integer;
	procedure SetDControlMax (window: DialogPtr; item: integer; value: integer);
	function GetDControlMin (window: DialogPtr; item: integer): integer;
	procedure SetDControlMin (window: DialogPtr; item: integer; value: integer);
	function GetDControlHilite (window: DialogPtr; item: integer): integer;
	procedure SetDControlHilite (window: DialogPtr; item: integer; hilite: integer);
	procedure DrawDItem (window: DialogPtr; item: integer);
	function GetPopupMHandle (window: DialogPtr; item: integer): MenuHandle;
	procedure SetPopUpMenuOnMouseDown (window: DialogPtr; item: integer; text: Str255);
	procedure GetPopUpItemText (window: DialogPtr; item: integer; var text: Str255);
	procedure SetWindowTitle (window: WindowPtr; title: Str255);
	function SelectedTextItem (window: DialogPtr): integer;
	procedure SelectDialogItem(window: DialogPtr; item: integer);
	procedure GetDialogTextSelection(window: DialogPtr; var item, start, fin: integer);
	procedure DrawTheFriggingGrowIcon (window: WindowPtr; bounds: Rect);
	procedure DisplayStyledString (window: DialogPtr; item: integer; s: Str255; selected: Boolean);
{ s= "font:size:style:just:text" }
	procedure DrawStyledTextUserItem( window: DialogPtr; item: integer; ft: MyFontType; face: Style; const data: Str255 );
//	procedure ShiftTab (window: DialogPtr);
	procedure ManualTab (window: DialogPtr; backwards: Boolean);
	function CountDItems (window: DialogPtr): integer;
	procedure DrawGrayRect (window: DialogPtr; item: integer; title: Str255);
	procedure SetDialogTextFont (window: DialogPtr; ft:MyFontType; face: Style);
	function ShutupTalkingAlertsModalFilter (window: DialogPtr; var event: EventRecord; var item: integer): Boolean;
	function StandardModalFilter (window: DialogPtr; var er: EventRecord; var item: integer): Boolean;
	function CancelModalFilter (window: DialogPtr; var er: EventRecord; var item: integer): Boolean;
	function DiscardModalFilter (window: DialogPtr; var er: EventRecord; var item: integer): Boolean;
	function TrackItems(window:WindowPtr; i1,i2,i3:integer):Boolean;
	function PointOverEnabledStaticTextItem( window: WindowPtr; localwhere: Point; var item: integer ): Boolean;
	function PointOverEditTextItem( window: WindowPtr; localwhere: Point; var item: integer ): Boolean;
	function OverEditTextItem: Boolean;
	procedure StyleTextBox( text: Handle; styles: StScrpHandle; var box: Rect; just: integer);
	procedure DialogGetTextDropInformation( window: DialogPtr; localwhere: Point; var field: integer; var offset: integer; hilite: RgnHandle; invert: RgnHandle );
{	procedure GetDAFont (var font: integer);  -- use LMGetDlgFont }
	procedure PenPatGray;
	procedure SafePlotCIcon( id: integer; const frame: Rect; selected: Boolean );
	procedure MyDialogCut( window: DialogPtr );
	procedure MyDialogPaste( window: DialogPtr );
	procedure MyDialogCopy( window: DialogPtr );
	procedure MyDialogDelete( window: DialogPtr );

	procedure SetEditTextEnable( window: DialogPtr; item: integer; enable, select: Boolean );
	// must be a paired textitem, useritem
//	procedure DisableLastEditText( window: DialogPtr; item: integer );
//	procedure SetNonLastEditText( window: DialogPtr; item: integer; enable, select: Boolean );
	procedure AppearanceHackFixStaticTextItem( window: DialogPtr; item: integer );

	procedure DrawEditTextOutline( window: DialogPtr; item: integer ); // must have a text item preceeding it
	procedure SetUpEditTextOutline( window: DialogPtr; item: integer ); // must have a text item preceeding it

implementation

	uses
		Palettes,  
		MyTypes, MyStrings, MyUtils, MyMemory, MySystemGlobals, MyStartup, MyMathUtils, MyLowLevel, 
		MyEvents, MyAssertions, MyControls;

{$ifc do_debug}
	var
		startup_check: integer;
{$endc}

	var
		gOutlineDeviceLoopProc:UniversalProcPtr;

	function IsControlDialogKind( kind: integer ): Boolean;
	begin
		IsControlDialogKind := band( kind, GoodBNOT(itemDisable) ) in 
				[kButtonDialogItem, kCheckBoxDialogItem, kRadioButtonDialogItem, kResourceControlDialogItem]
	end;

{$ifc do_debug}
	procedure AssertValidDialogItemCode( window: DialogPtr; item: integer );
	begin
		AssertDidStartup( startup_check );
		Assert( (window <> nil) & (0 < item) & (item <= CountDItems(window)) );
	end;

	procedure AssertValidDialogControlCode( window: DialogPtr; item: integer );
		var
			kind: integer;
			ih: Handle;
			box: Rect;
	begin
		AssertValidDialogItem( window, item );
		GetDialogItem( window, item, kind, ih, box );
		Assert( IsControlDialogKind( kind ) );
	end;

	procedure AssertValidDialogTextItemCode( window: DialogPtr; item: integer );
		var
			kind: integer;
			ih: Handle;
			box: Rect;
	begin
		AssertValidDialogItem( window, item );
		GetDialogItem( window, item, kind, ih, box );
		Assert( (band(kind,GoodBNOT(itemDisable)) in [statText, editText]) );
	end;

	procedure AssertValidDialogUserItemCode( window: DialogPtr; item: integer );
		var
			kind: integer;
			ih: Handle;
			box: Rect;
	begin
		AssertValidDialogItem( window, item );
		GetDialogItem( window, item, kind, ih, box );
		Assert( (band(kind,GoodBNOT(itemDisable)) in [userItem]) );
	end;

{$endc}

	procedure PenPatGray;
	begin
		AssertDidStartup( startup_check );
		if grey_pattern = nil then begin
			PenPat(GetQDGlobals^.gray);
		end else begin
			PenPixPat(grey_pattern);
		end;
	end;

	procedure ValidDItem( window: WindowPtr; item: integer );
		var
			frame: Rect;
	begin
		AssertValidDialogItem( window, item );
		GetDItemRect( window, item, frame );
		ValidRect( frame );
	end;

	procedure InvalDItem( window: WindowPtr; item: integer );
		var
			frame: Rect;
	begin
		AssertValidDialogItem( window, item );
		GetDItemRect( window, item, frame );
		InvalRect( frame );
	end;
	
	function SafeGetDialogItemAsControl( window: DialogPtr; item: integer; var ch: ControlHandle): OSStatus;
		var
			err: OSStatus;
	begin
		err := errItemNotControl;
		if has_Appearance then begin
			err := GetDialogItemAsControl( window, item, ch );
		end;
		SafeGetDialogItemAsControl := err;
	end;
	
	procedure GetDItemKind (window: DialogPtr; item: integer; var k: integer);
		var
			err: OSStatus;
			r: Rect;
			data: Handle;
			ch: ControlHandle;
	begin
		GetDialogItem(window, item, k, data, r);
		if k = editText then begin
			err := SafeGetDialogItemAsControl( window, item, ch );
			if err = noErr then begin
				if not GetControlEnable( ch ) then begin
					k := statText;
				end;
			end;
		end;
	end;

	function GetDItemKindF (window: DialogPtr; item: integer): integer;
		var
			k: integer;
	begin
		GetDItemKind(window, item, k);
		GetDItemKindF := k;
	end;

	function GetDControlHandle (window: DialogPtr; item: integer): ControlHandle;
		var
			err: OSStatus;
			kind: integer;
			ih: ControlHandle;
			box: Rect;
	begin
		AssertValidDialogItem( window, item );
		err := SafeGetDialogItemAsControl( window, item, ih );
		if err <> noErr then begin
//			AssertValidDialogControl( window, item );
			GetDialogItem( window, item, kind, Handle(ih), box );
		end;
		GetDControlHandle := ih;
	end;
	
	procedure AppearanceHackFixStaticTextItem( window: DialogPtr; item: integer );
		var
			err: OSStatus;
			ch: ControlHandle;
	begin
		AssertValidDialogTextItem( window, item );
		if has_Appearance & (system_version < $0850) then begin
			err := SafeGetDialogItemAsControl( window, item, ch );
			if err = noErr then begin
				SetControlEnable( ch, true );
			end;
		end;
	end;
	
	function CountTextItems( window: DialogPtr ): integer;
		var
			result: integer;
			i: integer;
			kind: integer;
	begin
		result := 0;
		for i := 1 to CountDItems( window ) do begin
			GetDItemKind( window, i, kind );
			if kind = editText then begin
				Inc(result);
			end;
		end;
		CountTextItems := result;
	end;
(*
	procedure DisableLastEditText( window: DialogPtr; item: integer );
		var
			err: OSStatus;
			ch: ControlHandle;
			kk: integer;
			data: Handle;
			r: Rect;
	begin
		AssertValidDialogTextItem( window, item );
		err := SafeGetDialogItemAsControl( window, item, ch );
		if err = noErr then begin
			SetControlEnable( ch, false );
		end else begin
			NonAppearanceSetDItemKind(window, item, statText);
			DialogPeek(window)^.editField := -1;
		end;
	end;
*)

	procedure NonAppearanceSetDItemKind (window: DialogPtr; item: integer; k: integer);
		var
			kk: integer;
			data: Handle;
			r: Rect;
	begin
		AssertValidDialogItem( window, item );
		GetDialogItem(window, item, kk, data, r);
		SetDialogItem(window, item, k, data, r);
	end;

	procedure SetEditTextEnable( window: DialogPtr; item: integer; enable, select: Boolean );
		var
			err: OSErr;
			ch: ControlHandle;
			kind: integer;
			s: Str255;
	begin
		AssertValidDialogUserItem( window, item + 1 );
		AssertValidDialogTextItem( window, item );
		GetDItemKind( window, item, kind );
		if enable <> (kind = editText) then begin
			if not enable & (SelectedTextItem(window) = item) then begin
				if CountTextItems( window ) > 1 then begin
					ManualTab( window, false );
				end else begin
					DialogPeek(window)^.editField := -1;
				end;
			end;
			err := SafeGetDialogItemAsControl( window, item, ch );
			if err = noErr then begin
				SetControlEnable( ch, enable );
			end else begin
				if enable then begin
					NonAppearanceSetDItemKind( window, item, editText );
					GetItemText( window, item, s );
					SetDialogItemText( Handle(GetDControlHandle( window, item )), s );
				end else begin
					NonAppearanceSetDItemKind( window, item, statText );
				end;
			end;
		end;
		if enable & select then begin
			SelectDialogItem( window, item );
		end;
		DrawEditTextOutline( window, item + 1 );
	end;

	procedure SetItemText (window: DialogPtr; item: integer; text: Str255);
		var
			ih: Handle;
			oldtext: Str255;
	begin
		AssertValidDialogTextItem( window, item );
		ControlHandle(ih) := GetDControlHandle( window, item );
		GetDialogItemText(ih, oldtext);
		if oldtext <> text then begin
			SetDialogItemText(ih, text);
		end;
	end;

	procedure GetItemText (window: DialogPtr; item: integer; var text: Str255);
	begin
		AssertValidDialogTextItem( window, item );
		GetDialogItemText( Handle(GetDControlHandle( window, item )), text );
	end;

	function GetItemTextF (window: DialogPtr; item: integer): Str255;
		var
			text: Str255;
	begin
		AssertValidDialogItem( window, item );
		GetItemText(window, item, text);
		GetItemTextF := text;
	end;

	var
		gODRect:Rect;
		gODEnabled:Boolean;

	procedure OutlineDeviceLoop (depth: integer; deviceFlags: integer; targetDevice: GDHandle; ignore:longint);
		var
			backGround,foreGround:RGBColor;
			junk_boolean:Boolean;
	begin
{$unused(deviceFlags, ignore)}
		if not gODEnabled then begin
			if depth=1 then begin
				PenPat(GetQDGlobals^.gray);
			end else begin
				MakeRGBColor($0000,$0000,$0000,backGround);
				MakeRGBColor($0000FFFF,$0000FFFF,$0000FFFF,foreGround);
				junk_boolean:=GetGray(targetDevice,backGround,foreGround);
				RGBForeColor(foreGround);
			end;
		end;
		FrameRoundRect(gODRect, 16, 16);
		PenPat(GetQDGlobals^.black);
		ForeColor(blackColor);
	end;

	procedure EraseDefault1(window: DialogPtr; item: integer);
	begin
		AssertValidDialogItem( window, item );
		SetPort( window );
		GetDItemRect( window, item, gODRect );
		InsetRect( gODRect, 2, 2 );
		PenSize( 3, 3 );
		ForeColor( whiteColor );
		FrameRoundRect( gODRect, 16, 16 );
		ForeColor( blackColor );
		PenNormal;
	end;

	procedure OutlineDefault1ForeBackground(window: DialogPtr; item: integer; foreground: Boolean);
	begin
{$ifc do_debug}
		AssertValidDialogUserItem( window, item );
{$endc}
		SetPort(window);
		GetDItemRect(window, item, gODRect);
		InsetRect(gODRect, 2, 2);
		gODEnabled := GetDControlEnable(window, 1) & (FrontWindow = window) & foreground;
		PenSize(3, 3);
		SafeDeviceLoopRect(gODRect, gOutlineDeviceLoopProc, 0, 0);
		PenNormal;
	end;

	procedure OutlineDefault1(window: DialogPtr; item: integer);
	begin
		OutlineDefault1ForeBackground( window, item, InForeground );
	end;

	procedure SetUpDefaultOutline(window: DialogPtr; def_item, user_item: integer; sethandler: Boolean);
		var
			box: Rect;
	begin
{$ifc do_debug}
		Assert( def_item = 1 ); { must be 1 for GetDControlEnable(window, 1) in OutlineDefault1ForeBackground }
		AssertValidDialogItem( window, def_item );
		AssertValidDialogUserItem( window, user_item );
		Assert( band(GetDItemKindF( window, def_item ),GoodBNOT(itemDisable)) = ctrlItem + btnCtrl );
		Assert( gOutlineDefault1Proc <> nil );
{$endc}
		GetDItemRect( window, def_item, box);
		InsetRect( box, -6,-6 );
		SetDItemRect( window, user_item, box );
		if sethandler then begin
			SetUserItemProc( window, user_item, gOutlineDefault1Proc );
		end;
	end;

	procedure DrawEditTextOutline( window: DialogPtr; item: integer );
		var
			r: Rect;
			k: integer;
	begin
		AssertValidDialogUserItem( window, item );
		AssertValidDialogTextItem( window, item - 1 );
		SetPort( window );
		GetDItemRect( window, item, r );
		GetDItemKind( window, item - 1, k );
		PenNormal;
		if k = statText then begin
			FrameRect( r );
			PenPat( GetQDGlobals^.gray );
			PenMode( patBic );
			PaintRect( r );
			PenNormal;
		end else begin
			FrameRect( r );
		end;
	end;
	
	procedure SetUpEditTextOutline (window: DialogPtr; item: integer);
		var
			r: Rect;
	begin
		AssertValidDialogUserItem( window, item );
		AssertValidDialogTextItem( window, item - 1 );
		GetDItemRect( window, item - 1, r );
		InsetRect( r, -3, -3 );
		SetDItemRect( window, item, r );
		SetUserItemProc(window, item, gDrawEditTextOutlineProc);
	end;

	procedure FlashDItem(window: DialogPtr; item: integer);
		var
			f: UInt32;
	begin
		AssertValidDialogControl( window, item );
		SetDControlHilite(window, item, kControlButtonPart);
		Delay(2, f);
		SetDControlHilite(window, item, 0);
	end;

	procedure SetDItemRect (window: DialogPtr; item: integer; rr: Rect);
		var
			kind: integer;
			data: Handle;
			r: Rect;
	begin
		AssertValidDialogItem( window, item );
		GetDialogItem(window, item, kind, data, r);
		SetDialogItem(window, item, kind, data, rr);
	end;

	procedure GetDItemRect (window: DialogPtr; item: integer; var rr: Rect);
		var
			kind: integer;
			data: Handle;
	begin
		AssertValidDialogItem( window, item );
		GetDialogItem(window, item, kind, data, rr);
	end;

	procedure SetDControlRect( window: DialogPtr; item: integer; const frame: Rect );
	begin
		AssertValidDialogControl( window, item );
		SetDItemRect( window, item, frame );
		SetControlRect( GetDControlHandle( window, item ), frame );
	end;

	function IsDialogItemHidden( window: WindowPtr; item: integer ): Boolean;
		var
			frame, wframe: Rect;
	begin
		GetDItemRect( window, item, frame );
		SetRect( wframe, -2000, -2000, 2000, 2000 );
		IsDialogItemHidden := not ContainedRect( wframe, frame );
	end;

	procedure OffsetDItem( window: DialogPtr; item: integer; dh, dv: integer );
		var
			kind: integer;
			data: Handle;
			r: Rect;
	begin
		AssertValidDialogItem( window, item );
		GetDialogItem( window, item, kind, data, r );
		OffsetRect( r, dh, dv );
		SetDialogItem( window, item, kind, data, r );
		if IsControlDialogKind( kind ) then begin
			CleanMoveControl( ControlHandle( data ), r.left, r.top );
		end;
	end;
(*
	function GetDItemHandle (window: DialogPtr; item: integer): Handle;
		var
			kind: integer;
			data: Handle;
			r: Rect;
	begin
		AssertValidDialogItem( window, item );
		GetDialogItem(window, item, kind, data, r);
		GetDItemHandle := data;
	end;

	procedure SetDItemHandle (window: DialogPtr; item: integer; data: univ Handle);
		var
			kind: integer;
			hh: Handle;
			r: Rect;
	begin
		AssertValidDialogItem( window, item );
		GetDialogItem(window, item, kind, hh, r);
		SetDialogItem(window, item, kind, data, r);
	end;
*)
	procedure SetUserItemProc (window: DialogPtr; item: integer; proc: UniversalProcPtr);
		var
			kind: integer;
			hh: Handle;
			r: Rect;
	begin
		Assert( proc <> nil );
		AssertValidDialogUserItem( window, item );
		GetDialogItem(window, item, kind, hh, r);
		SetDialogItem(window, item, kind, Handle(proc), r);
	end;

	function GetDControlHilite (window: DialogPtr; item: integer): integer;
	begin
		AssertValidDialogControl( window, item );
		GetDControlHilite := GetControlHilite( GetDControlHandle(window, item) );
	end;

	procedure SetDControlHilite (window: DialogPtr; item: integer; hilite: integer);
	begin
		AssertValidDialogControl( window, item );
		SetControlHilite( GetDControlHandle(window, item), hilite );
	end;

	function GetDControlEnable (window: DialogPtr; item: integer): Boolean;
	begin
		AssertValidDialogControl( window, item );
		GetDControlEnable := GetControlEnable(GetDControlHandle(window, item));
	end;

	procedure SetDControlEnable (window: DialogPtr; item: integer; on: Boolean);
	begin
		AssertValidDialogControl( window, item );
		SetControlEnable( GetDControlHandle(window, item), on );
	end;

	function GetDControlTitle (window: DialogPtr; item: integer): Str255;
		var
			s: Str255;
	begin
		GetControlTitle(GetDControlHandle(window, item), s);
		GetDControlTitle := s;
	end;

	procedure SetDControlTitle (window: DialogPtr; item: integer; s: Str255);
		var
			ch: ControlHandle;
			old: Str255;
	begin
		ch := GetDControlHandle(window, item);
		GetControlTitle(ch, old);
		if old <> s then begin
			SetControlTitle(ch, s);
		end;
	end;

	function GetDControlBoolean (window: DialogPtr; item: integer): Boolean;
	begin
		GetDControlBoolean := GetControlBoolean(GetDControlHandle(window, item));
	end;

	procedure SetDControlBoolean (window: DialogPtr; item: integer; value: Boolean);
	begin
		SetControlBoolean(GetDControlHandle(window, item), value);
	end;

	procedure ToggleDControlBoolean (window: DialogPtr; item: integer);
	begin
		ToggleControlBoolean( GetDControlHandle(window, item) );
	end;

	function GetDControlValue (window: DialogPtr; item: integer): integer;
	begin
		GetDControlValue := GetControlValue(GetDControlHandle(window, item));
	end;

	procedure SetDControlValue (window: DialogPtr; item: integer; value: integer);
	begin
		SetControlValue(GetDControlHandle(window, item), value);
	end;

	function GetDControlMax (window: DialogPtr; item: integer): integer;
	begin
		GetDControlMax := GetControlMaximum(GetDControlHandle(window, item));
	end;

	procedure SetDControlMax (window: DialogPtr; item: integer; value: integer);
	begin
		SetControlMaximum(GetDControlHandle(window, item), value);
	end;

	function GetDControlMin (window: DialogPtr; item: integer): integer;
	begin
		GetDControlMin := GetControlMinimum(GetDControlHandle(window, item));
	end;

	procedure SetDControlMin (window: DialogPtr; item: integer; value: integer);
	begin
		SetControlMinimum(GetDControlHandle(window, item), value);
	end;

	procedure DrawDItem (window: DialogPtr; item: integer);
	begin
		Draw1Control(GetDControlHandle(window, item));
	end;

	function GetPopupMHandle (window: DialogPtr; item: integer): MenuHandle;
		type
			MenuHandlePtr = ^MenuHandle;
			MenuHandleHandle = ^MenuHandlePtr;
	begin
		GetPopupMHandle := MenuHandleHandle(GetDControlHandle(window, item)^^.contrlData)^^;
	end;

	procedure SetPopUpMenuOnMouseDown (window: DialogPtr; item: integer; text: Str255);
		var
			mh: MenuHandle;
			i, index: integer;
			s: Str255;
	begin
		mh := GetPopupMHandle(window, item);
		if text = '' then begin
			GetMenuItemText(mh, 1, text);
		end;
		GetMenuItemText(mh, 2, s);
		if s = '-' then begin
			DeleteMenuItem(mh, 2);
			DeleteMenuItem(mh, 1);
		end;
		index := 0;
		for i := 1 to CountMItems(mh) do begin
			GetMenuItemText(mh, i, s);
			if (IUEqualString(s, text) = 0) then begin
				index := i;
				leave;
			end;
		end;
		if index = 0 then begin
			InsertMenuItem(mh, '(-;fred', 0);
			SetMenuItemText(mh, 1, text);
			index := 1;
		end;
		SetDControlValue(window, item, index);
	end;

	procedure GetPopUpItemText (window: DialogPtr; item: integer; var text: Str255);
	begin
		GetMenuItemText(GetPopupMHandle(window, item), GetDControlValue(window, item), text);
	end;

	procedure SetWindowTitle (window: WindowPtr; title: Str255);
		var
			s: Str255;
	begin
		Assert( window <> nil );
		GetWTitle(window, s);
		if s <> title then begin
			SetWTitle(window, title);
		end;
	end;

	function SelectedTextItem (window: DialogPtr): integer;
		var
			field: integer;
	begin
		Assert( window <> nil );
		field := DialogPeek(window)^.editField + 1;
		if field > 0 then begin
			if GetDItemKindF( window, field ) <> editText then begin
				field := 0;
			end;
		end;
		SelectedTextItem := field;
	end;

	procedure SelectDialogItem(window: DialogPtr; item: integer);
	begin
		AssertValidDialogItem( window, item );
		SelectDialogItemText(window, item, 0, maxint);
	end;

	procedure GetDialogTextSelection(window: DialogPtr; var item, start, fin: integer);
	begin
		Assert( window <> nil );
		item := SelectedTextItem( window );
		if item > 0 then begin
			start := DialogPeek(window)^.textH^^.selStart;
			fin := DialogPeek(window)^.textH^^.selEnd;
		end else begin
			start := -1;
			fin := -1;
		end;
		if item > 0 then begin
			AssertValidDialogItem( window, item );
		end;
	end;

	function CountDItems (window: DialogPtr): integer;
	begin
		Assert( window <> nil );
{    count := CountDITL(window);}
		CountDItems := integerH(DialogPeek(window)^.items)^^ + 1;
	end;

	procedure ManualTab (window: DialogPtr; backwards: Boolean);
		var
			orgitem, i, count: integer;
	begin
		Assert( window <> nil );
		orgitem := SelectedTextItem(window);
		count := CountDItems(window);
		if (orgitem > 0) & (count > 1) then begin
			i := orgitem;
			repeat
				if backwards then begin
					i := i - 1;
					if i = 0 then begin
						i := count;
					end;
				end else begin
					i := i + 1;
					if i > count then begin
						i := 1;
					end;
				end;
			until (i = orgitem) | ((GetDItemKindF( window, i ) = editText) & not IsDialogItemHidden( window, i));
		end;
		if GetDItemKindF( window, i ) = editText then begin
			SelectDialogItem(window, i);
		end else begin
			SysBeep( 1 );
		end;
	end;
(*
	procedure ShiftTab (window: DialogPtr);
		var
			orgitem, i, count: integer;
	begin
		Assert( window <> nil );
		orgitem := SelectedTextItem(window);
		count := CountDItems(window);
		if (orgitem > 0) & (count > 1) then begin
			i := orgitem;
			repeat
				i := i - 1;
				if i = 0 then begin
					i := count;
				end;
			until (i = orgitem) | (GetDItemKindF( window, i ) = editText);
		end;
		if GetDItemKindF( window, i ) = editText then begin
			SelectDialogItem(window, i);
		end;
	end;
*)

	procedure DrawTheFriggingGrowIcon (window: WindowPtr; bounds: Rect);
		var
			oldclip: RgnHandle;
	begin
		Assert( window <> nil );
		SetPort(window);
		PenNormal;
		SetClipRectRegion( bounds, oldclip );
		DrawGrowIcon( window );
		RestoreClipRegion( oldclip );
	end;

	function DoButtonKey(window:DialogPtr; item:integer; var er: EventRecord; var item_hit:integer):Boolean;
	begin
		if GetDControlEnable(window,item) then begin
			FlashDItem(window, item);
			item_hit:=item;
			DoButtonKey := true;
		end else begin
			SysBeep(10);
			er.what:=nullEvent;
			DoButtonKey := false;
		end;
	end;

	procedure PostMouseDown( window: WindowPtr );
		var
			structRgn: RgnHandle;
			structRect: Rect;
			where: Point;
			err: OSErr;
			event: EvQElPtr;
	begin
		SetPort( window );
		structRgn := WindowPeek(window)^.strucRgn;
		if structRgn <> nil then begin
			structRect := structRgn^^.rgnBBox;
		end;
		where.h := (structRect.right + structRect.left) div 2;
		where.v := structRect.top + 1;
		err := PPostEvent( mouseDown, 0, event );
		if err = noErr then begin
			event^.evtQWhere := where;
		end;
	end;

	function ShutupTalkingAlertsModalFilter (window: DialogPtr; var event: EventRecord; var item: integer): Boolean;
	begin
{$unused( item )}
		if (event.what = updateEvt) & shutup_talking_alerts then begin
			PostMouseDown( window );
			shutup_talking_alerts := false;
		end;
		ShutupTalkingAlertsModalFilter := false;
	end;

	function StandardModalFilter (window: DialogPtr; var er: EventRecord; var item: integer): Boolean;
	begin
		Assert( window <> nil );
		StandardModalFilter := false;
		if ShutupTalkingAlertsModalFilter( window, er, item ) then begin
			StandardModalFilter := true;
		end else if EventIsKeyDown( er ) & EventHasOK( er ) then begin
			StandardModalFilter:= DoButtonKey(window, i_ok, er, item);
		end;
	end;

	function CancelModalFilter (window: DialogPtr; var er: EventRecord; var item: integer): Boolean;
	begin
		Assert( window <> nil );
		CancelModalFilter := false;
		if StandardModalFilter(window, er, item) then begin
			CancelModalFilter := true;
		end else if EventIsKeyDown( er ) & EventHasCancel( er ) then begin
			CancelModalFilter:= DoButtonKey(window, i_cancel, er, item);
		end;
	end;

	function DiscardModalFilter (window: DialogPtr; var er: EventRecord; var item: integer): Boolean;
	begin
		Assert( window <> nil );
		DiscardModalFilter := false;
		if CancelModalFilter(window, er, item) then begin
			DiscardModalFilter := true;
		end else if EventIsKeyDown( er ) & EventHasDiscard( er ) then begin
			DiscardModalFilter:= DoButtonKey(window, i_discard, er, item);
		end;
	end;

	procedure SetMyDialogFont(ft:MyFontType);
		var
			font, size:integer;
	begin
		AssertDidStartup( startup_check );
		GetMyFonts(ft, font, size);
		SetDialogFont(font);
	end;

	procedure SetDialogTextFont (window: DialogPtr; ft:MyFontType; face: Style);
		var
			saved: SavedPortInfo;
			fi: FontInfo;
			te: TEHandle;
			font, size: integer;
	begin
		EnterPort(window, ft, saved);
		TextFace( face );
		GetFontInfo(fi);
		GetMyFonts(ft, font, size);
		te := DialogPeek(window)^.textH;
		te^^.txFont := font;
		te^^.txSize := size;
		te^^.txFace := face;
		te^^.lineHeight := fi.ascent + fi.descent + fi.leading;
		te^^.fontAscent := fi.ascent;
		TECalText(te);
		ExitPort(saved);
	end;

	procedure DrawGrayRect (window: DialogPtr; item: integer; title: Str255);
		const
			left_indent = 20;
			gap = 2;
		var
			r, er: Rect;
			fi: FontInfo;
			sw: integer;
			saved: SavedPortInfo;
	begin
		EnterPort(window, MFT_Geneva9, saved);
		GetDItemRect(window, item, r);
		GetFontInfo(fi);
		MoveTo(r.left + left_indent, r.top + fi.ascent);
		sw := StringWidth(title);
		er.top := r.top;
		er.bottom := er.top + fi.ascent + fi.descent;
		er.left := r.left + left_indent;
		er.right := er.left + sw;
		EraseRect(er);
		DrawString(title);
		PenPatGray;
		r.top := r.top + (fi.ascent) div 2;
		MoveTo(er.left - gap, r.top);
		LineTo(r.left, r.top);
		LineTo(r.left, r.bottom);
		LineTo(r.right, r.bottom);
		LineTo(r.right, r.top);
		LineTo(er.right + gap, r.top);
		PenNormal;
		ExitPort(saved);
	end;

	function TrackItems(window:WindowPtr; i1,i2,i3:integer):Boolean;
		var
			rgn:RgnHandle;
		procedure AddItem(i:integer);
			var
				itemrect:Rect;
				tmp:RgnHandle;
		begin
			if i <> 0 then begin
				GetDItemRect(window,i,itemrect);
				tmp := MNewRgn;
				RectRgn(tmp, itemrect);
				UnionRgn(rgn, tmp, rgn);
				MDisposeRgn(tmp);
			end;
		end;
		var
			inside,newinside:Boolean;
			mouse:Point;
	begin
		Assert( window <> nil );
		rgn := MNewRgn;
		AddItem(i1);
		AddItem(i2);
		AddItem(i3);
		InvertRgn(rgn);
		inside:=true;
		while StillDown do begin
			GetMouse(mouse);
			newinside := PtInRgn(mouse,rgn);
			if newinside <> inside then begin
				InvertRgn(rgn);
				inside := newinside;
			end;
		end;
		if inside then begin
			InvertRgn(rgn);
		end;
		TrackItems := inside;
	end;

	procedure DrawStyledTextUserItem( window: DialogPtr; item: integer; ft: MyFontType; face: Style; const data: Str255 );
		var
			box: Rect;
			fi: FontInfo;
			saved: SavedPortInfo;
	begin
		Assert( window <> nil );
		EnterPort( window, ft, saved );
		TextFace( face );
		GetDItemRect( window, item, box );
		GetFontInfo( fi );
		MoveTo( box.left, box.top + fi.ascent );
		EraseRect( box );
		DrawString( data );
		ExitPort( saved );
	end;

	procedure DisplayStyledString (window: DialogPtr; item: integer; s: Str255; selected: Boolean);
		procedure TESetColour( teh: TEHandle; const colour: RGBColor );
			var
				tsr:TextStyle;
		begin
			tsr.tsColor := colour;
			TESetStyle( doColor, tsr, false, teh );
		end;

		procedure TESetFace( teh: TEHandle; face: Style );
			var
				tsr:TextStyle;
		begin
			tsr.tsFace := face;
			TESetStyle( doFace, tsr, false, teh );
		end;
		
		procedure TESetLinkStyle( teh: TEHandle );
			var
				tsr:TextStyle;
		begin
			tsr.tsFace := [underline];
			tsr.tsColor.red := $0000;
			tsr.tsColor.green := $0000;
			tsr.tsColor.blue := $FFFF;
			TESetStyle( doColor + doFace, tsr, false, teh );
		end;
		
		var
			box: Rect;
			just: integer;
			this: Str255;
			font, size, i, j, def_font, def_size: integer;
			st: Style;
			fi: FontInfo;
			fixsize: Boolean;
			oldfont, oldsize: integer;
			oldface: Style;
			hot: Boolean; { parse for <> and blue-underline them }
			teh:TEHandle;
			pos_left, pos_right: integer;
			docolour: Boolean;
			thecolour: RGBColor;
	begin
		Assert( window <> nil );
		SetPort(window);
		oldfont := window^.txFont;
		oldsize := window^.txSize;
		oldface := window^.txFace;
		docolour := false;
		GetMyFonts(MFT_Geneva9, def_font, def_size);
		GetDItemRect(window, item, box);
		if SplitAt(s, ':', this, s) then begin
			hot := false;
			fixsize := false;
			if this = '' then begin
				font := def_font;
			end else begin
				GetFNum(this, font);
				if font = 0 then begin
					fixsize := true;
					font := def_font;
				end;
			end;
			if SplitAt(s, ':', this, s) then begin
				if this = '' then begin
					size := def_size;
				end else begin
					size := StrToNum(this);
				end;
				if SplitAt(s, ':', this, s) then begin
					st := [];
					i := 1;
					while i <= length(this) do begin
						case UpperCaseChar( this[i] ) of
							'0'..'7':begin
								st := st + [StyleItem(ord(this[i]) - 48)];
								Inc(i);
							end;
							'H': begin
								hot := true;
								Inc(i);
							end;
							'C': begin
								Assert( i + 6 <= length(this) );
								Assert( not docolour );
								docolour := true;
								Inc(i);
								Assert( IsHexDigit( this[i] ) & IsHexDigit( this[i+1] ) );
								thecolour.red := HexToNum( copy( this, i, 2 ) );
								thecolour.red := 257 * thecolour.red;
								i := i + 2;
								Assert( IsHexDigit( this[i] ) & IsHexDigit( this[i+1] ) );
								thecolour.green := HexToNum( copy( this, i, 2 ) );
								thecolour.green := 257 * thecolour.green;
								i := i + 2;
								Assert( IsHexDigit( this[i] ) & IsHexDigit( this[i+1] ) );
								thecolour.blue := HexToNum( copy( this, i, 2 ) );
								thecolour.blue := 257 * thecolour.blue;
								i := i + 2;
							end;
							otherwise begin
								Assert( false );
								leave;
							end;
						end;
					end;
					if SplitAt(s, ':', this, s) then begin
						if this = '' then begin
							just := teJustLeft;
						end else begin
							just := StrToNum(this);
						end;
						TextFont(font);
						TextSize(size);
						TextFace(st);
						if fixsize then begin
							GetFontInfo(fi);
							while (fi.ascent + fi.descent > box.bottom - box.top) do begin
								if size > 48 then begin
									size := 48;
								end else if size > 36 then begin
									size := 36;
								end else if size > 27 then begin
									size := 27;
								end else if size > 24 then begin
									size := 24;
								end else if size > 18 then begin
									size := 18;
								end else if size > 14 then begin
									size := 14;
								end else if size > 12 then begin
									size := 12;
								end else begin
									size := 9;
									TextSize(size);
									leave;
								end;
								TextSize(size);
								GetFontInfo(fi);
							end;
						end;

						TextFace([]); // Avoid underlining the space we add
						teh := TEStyleNew(box,box);
						if teh<>nil then begin
							case just of
								teJustLeft: begin
									pos_left := 0;
									pos_right := length(s);
									s := s + spc;
								end;
								teJustCenter: begin
									pos_left := 1;
									pos_right := length(s)+1;
									s := spc + s + spc;
								end;
								teJustRight: begin
									pos_left := 1;
									pos_right := length(s) + 1;
									s := spc + s;
								end;
							end;
							TESetText(@s[1],length(s),teh);
							TESetAlignment(just,teh);

							TESetSelect( pos_left, pos_right, teh );
							TESetFace( teh, st );

							if hot then begin
								for i := 1 to length(s) do begin
									if s[i] = '<' then begin
										j := i + 1;
										while (j <= length(s)) & (s[j] <> '>') do begin
											j := j + 1;
										end;
										TESetSelect(i,j-1,teh);
										TESetLinkStyle( teh );
									end;
								end;
							end;
							if docolour then begin
								TESetSelect( pos_left, pos_right, teh );
								TESetColour( teh, thecolour );
							end;
							if selected then begin
								TESetSelect( pos_left, pos_right, teh );
								TEActivate( teh );
							end else begin
								TESetSelect( 0, 0, teh );
							end;
							TEUpdate(box,teh);
							TEDispose(teh);
						end;

					end;
				end;
			end;
		end;
		TextFont(oldfont);
		TextSize(oldsize);
		TextFace(oldface);
	end;

	function PointOverEnabledStaticTextItem( window: WindowPtr; localwhere: Point; var item: integer ): Boolean;
	begin
		Assert( window <> nil );
		item := FindDialogItem(window, localwhere) + 1;
		if item > 0 then begin
			if GetDItemKindF(window, item) <> statText then begin
				item := 0;
			end;
		end;
		PointOverEnabledStaticTextItem := item > 0;
	end;

	function PointOverEditTextItem( window: WindowPtr; localwhere: Point; var item: integer ): Boolean;
	begin
		Assert( window <> nil );
		item := FindDialogItem(window, localwhere) + 1;
		if item > 0 then begin
			if GetDItemKindF(window, item) <> editText then begin
				item := 0;
			end;
		end;
		PointOverEditTextItem := item > 0;
	end;

	function OverEditTextItem: Boolean;
		var
			window: WindowPtr;
			over: Boolean;
			localpt: Point;
			item: integer;
	begin
		window := FrontWindow;
		over := false;
		if (window <> nil) & (WindowPeek(window)^.windowKind = kDialogWindowKind) then begin
			SetPort(window);
			GetMouse(localpt);
			over := PointOverEditTextItem( window, localpt, item );
		end;
		OverEditTextItem := over;
	end;

	procedure DialogGetTextDropInformation( window: DialogPtr; localwhere: Point; var field: integer; var offset: integer; hilite: RgnHandle; invert: RgnHandle );
		procedure GetOffsetAndInsertionRect( te: TEHandle; localwhere: Point; var offset: integer; var insertion: Rect );
			var
				basepoint: Point;
				theStyle: TextStyle;
				lineHeight: integer;
				fontAscent: integer;
		begin
			offset := TEGetOffset( localwhere, te );
			basepoint := TEGetPoint( offset, te );
			TEGetStyle( offset, theStyle, lineHeight, fontAscent, te );
			insertion.left := basepoint.h;
			insertion.right := insertion.left + 2;
			insertion.bottom := basepoint.v;
			insertion.top := insertion.bottom - lineHeight;
		end;

		const
			v_offset = 5000;
		var
			field_contents: Str255;
			field_rect, insertion_rect: Rect;
			te: TEHandle;
			saved: SavedPortInfo;
	begin
		if PointOverEditTextItem( window, localwhere, field ) then begin
			GetDItemRect( window, field, field_rect );
			InsetRect( field_rect, -2, -2 );
			RectRgn( hilite, field_rect );
			InsetRect( field_rect, 2, 2 );
			if SelectedTextItem( window ) = field then begin
				GetOffsetAndInsertionRect( DialogPeek(window)^.textH, localwhere, offset, insertion_rect );
			end else begin
				{ enter the window, set the font info }
				EnterPort( window, MFT_Geneva9, saved );
				TextFont( DialogPeek(window)^.textH^^.txFont );
				TextSize( DialogPeek(window)^.textH^^.txSize );
				{ put everything off the screen }
				OffsetRect( field_rect, 0, v_offset);
				localwhere.v := localwhere.v + v_offset;
				{ create a te rect and see where the mouse is }
				te := TENew( field_rect, field_rect );
				GetItemText( window, field, field_contents );
				TESetText( @field_contents[1], length(field_contents), te );
				GetOffsetAndInsertionRect( te, localwhere, offset, insertion_rect );
				TEDispose( te );
				{ push the insertion rect back in to place }
				OffsetRect( insertion_rect, 0, -v_offset);
				{ restore the state }
				ExitPort( saved );
			end;
			RectRgn( invert, insertion_rect );
		end;
	end;

	procedure StyleTextBox( text: Handle; styles: StScrpHandle; var box: Rect; just: integer);
		var
			te: TEHandle;
			r: Rect;
			waslocked: boolean;
	begin
		Assert( text <> nil );
		HLockState( text, waslocked );
		if styles = nil then begin
			TETextBox( text^, MGetHandleSize(text), box, just);
		end else begin
			te := TEStyleNew( box, box );
			TEStyleInsert(text^, MGetHandleSize(text), StScrpHandle(styles), te);
			TEUpdate(r, te);
			TEDispose(te);
		end;
		HRestoreLockState( text, waslocked );
	end;

	procedure SafePlotCIcon( id: integer; const frame: Rect; selected: Boolean );
		var
			icon: CIconHandle;
			oldicon: Handle;
			junk: OSErr;
	begin
		if has_ColourQuickDraw then begin
			icon := GetCIcon( id );
			Assert( icon <> nil );
			if icon <> nil then begin
				junk := PlotCIconHandle( frame, kAlignNone, Choose(selected, kTransformSelected, kTransformNone), icon );
{			Assert( junk = noErr );} { returns error in selected case - weird }
				DisposeCIcon( icon );
			end;
		end else begin
			icon := CIconHandle(GetResource( 'cicn', id ));
			if icon <> nil then begin
				MHLock( icon );
				if (RectWidth( icon^^.iconMask.bounds ) = 32) & (RectHeight( icon^^.iconMask.bounds ) = 32)
						& (RectWidth( icon^^.iconBMap.bounds ) = 32) & (RectHeight( icon^^.iconBMap.bounds ) = 32) 
						& (icon^^.iconMask.rowBytes = 4) & (icon^^.iconBMap.rowBytes = 4) then begin
					if MNewHandle( oldicon, 128 ) = noErr then begin
						BlockMoveData( AddPtrLong( @icon^^.iconMaskData, 128 ), oldicon^, 128 );
						PlotIcon( frame, oldicon );
						if selected then begin
							InvertRect( frame );
						end;
						MDisposeHandle( oldicon );
					end;
				end;
				MHUnlock( Handle(icon) );
				MHPurge( Handle(icon) );
			end;
		end;
	end;

const funcKeyChar = $10;

	procedure SendFakeDialogKeyEvent( window: DialogPtr; code: integer; ch: integer );
		var
			er: EventRecord;
			junk_boolean: Boolean;
			junk_window: WindowPtr;
			junk_item: integer;
	begin
		SetPort( window );
		er.what := keyDown;
		er.message := code shl 8 + ch;
		er.when := TickCount;
		GetMouse( er.where );
		er.modifiers := 0;
		if IsDialogEvent( er ) then begin
			junk_boolean := DialogSelect( er, junk_window, junk_item );
		end;
	end;
	
	procedure MyDialogCut( window: DialogPtr );
	begin
		if has_Appearance & (system_version < $0850) then begin
			SendFakeDialogKeyEvent( window, cutKeyCode, funcKeyChar );
		end else begin
			DialogCut( window );
		end;
	end;
	
	procedure MyDialogPaste( window: DialogPtr );
	begin
		if has_Appearance & (system_version < $0850) then begin
			SendFakeDialogKeyEvent( window, pasteKeyCode, funcKeyChar );
		end else begin
			DialogPaste( window );
		end;
	end;
	
	procedure MyDialogCopy( window: DialogPtr );
	begin
		if has_Appearance & (system_version < $0850) then begin
			SendFakeDialogKeyEvent( window, copyKeyCode, funcKeyChar );
		end else begin
			DialogCopy( window );
		end;
	end;
	
	procedure MyDialogDelete( window: DialogPtr );
	begin
		if has_Appearance & (system_version < $0850) then begin
			SendFakeDialogKeyEvent( window, clearKeyCode, clearChar );
		end else begin
			DialogDelete( window );
		end;
	end;

	function InitMyDialogs(var msg: integer): OSStatus;
		var
			sysenv: SysEnvRec;
	begin
{$unused(msg)}
		DidStartup( startup_check );
		shutup_talking_alerts := false;
		gShutupTalkingAlertsModalFilterProc := NewModalFilterProc(ShutupTalkingAlertsModalFilter);
		gStandardModalFilterProc := NewModalFilterProc(StandardModalFilter);
		gCancelModalFilterProc := NewModalFilterProc(CancelModalFilter);
		gDiscardModalFilterProc := NewModalFilterProc(DiscardModalFilter);
		gOutlineDefault1Proc := NewUserItemProc(OutlineDefault1);
		gOutlineDeviceLoopProc := NewDeviceLoopDrawingProc(OutlineDeviceLoop);
		gDrawEditTextOutlineProc := NewUserItemProc(DrawEditTextOutline);
		if (SysEnvirons(1, sysenv) = noErr) & sysenv.hasColorQD then begin
			grey_pattern := NewPixPat;
		end else begin
			grey_pattern := nil;
		end;
		MakeRGBColor($8000,$8000,$8000,grey_colour);
		if grey_pattern <> nil then begin
			MakeRGBPat(grey_pattern, grey_colour);
		end;
		InitMyDialogs := noErr;
	end;
	
	procedure FinishMyDialogs;
	begin
		if grey_pattern <> nil then begin
			DisposePixPat( grey_pattern );
			grey_pattern := nil;
		end;
	end;

	procedure StartupDialogs;
	begin
		SetStartup( InitMyDialogs, nil, 0, FinishMyDialogs );
	end;

end.
