unit MyErrorStrings;

interface

	uses
		MacOS;

	const
		error_id = 925; { ERRS, TEXT clever alert.  override ERRS with ERRS=128 }

	function LowErrorString (id: integer; err: OSStatus; var e: Str255): Boolean;

	function ErrorStr( err: OSStatus ): Str255;
	function ErrorString ( err: OSStatus; var e: Str255 ): Boolean;

implementation

	uses
		MyMemory;

	function LowErrorString (id: integer; err: OSStatus; var e: Str255): Boolean;
		var
			data: Handle;
			s, n: Str255;
			left: longint;
			oe: OSErr;
			p: Ptr;
			len: integer;
	begin
		LowErrorString := false;
		NumToString(err, n);
		e := n;
		data := GetResource('ERRS', id);
		if (data <> nil) & (data^ <> nil) then begin
			MHNoPurge(data);
			left := MGetHandleSize(data);
			p := data^;
			while (left > 3) do begin
				BlockMoveData(p, @oe, 2);
				p := Ptr(ord(p) + 2);
				len := BAND(p^, $FF);
				BlockMoveData(p, @s, len + 1);
				p := Ptr(ord(p) + len + 1);
				if err = oe then begin
					e := s;
					LowErrorString := true;
					leave;
				end;
				left := left - (2 + 1 + len);
			end;
			MHPurge(data);
		end;
	end;

	function ErrorStr( err: OSStatus ): Str255;
		var
			dummy: Boolean;
			e: Str255;
	begin
		dummy := ErrorString( err, e );
		ErrorStr := e;
	end;

	function ErrorString ( err: OSStatus; var e: Str255 ): Boolean;
		var
			result: Boolean;
	begin
		result := LowErrorString( 128, err, e );
		if not result then begin
			result := LowErrorString( error_id, err, e );
		end;
		ErrorString := result;
	end;

end.
