unit MyExpiry;

interface

	function ExpiredVersion( notify, expire: longint ): Boolean;
{ Pass it the number of months until it notifies/expires }

implementation

	uses
		MyStrings, MyEmergencyNotifier, MyUtils, MyTypes, MySystemGlobals,
		MyRealCompSecs;

	function ExpiredVersion( notify, expire: longint ): Boolean;
		const
			month_in_seconds = longint(31) * day_in_seconds;
		var
			date: UInt32;
			diff: longint;
	begin
		ExpiredVersion := false;
		if version.numericVersion.stage <> $80 then begin
			GetDateTime(date);
			diff := date - realcompsecs;
			if diff >= expire * month_in_seconds then begin
				EmergencyNotify('This developmental version has expired.  Set your clock back, or get a new version');
				ExpiredVersion := true;
			end else if diff >= notify * month_in_seconds then begin
				EmergencyNotify('This developmental version has expired.  It will work for a while, and then stop working forever.  Get a new version');
			end;
		end;
	end;


end.
