unit MyGrowZones;

interface

	procedure StartupGrowZones;
	procedure ConfigureGrowZones(size: longint);
	function MemoryCritical: Boolean;
	function EnoughSpace (total, contig: longint): Boolean;
	procedure IdleGrowZone; { Called by IdleStartup, you can call it yourself }

implementation

	uses
		MyStartup;

{$ifc do_debug}
	var
		startup_check: integer;
{$endc}

	var
		gz_size: longint;

	function EnoughSpace (total, contig: longint): Boolean;
		var
			t, c: longint;
	begin
		AssertDidStartup( startup_check );
		PurgeSpace(t, c);
		EnoughSpace := (t >= total + gz_size) & (c >= contig);
	end;

	function MemoryCritical: Boolean;
	begin
		AssertDidStartup( startup_check );
		MemoryCritical := not EnoughSpace(0, 0)
	end;

	procedure IdleGrowZone;
	begin
	end;
	
	procedure StartupGrowZones;
	begin
	end;
	
	procedure ConfigureGrowZones(size: longint);
	begin
		DidStartup( startup_check );
		gz_size := size;
		StartupGrowZones;
	end;

end.