unit MyKeychainMenu;

interface

	uses
		MacOS;
		
	procedure StartupKeychainMenu;

implementation

	uses
		MyStartup, MyKeychain, MyFMenus, MyStrings, MyMenus;

	const
		kKCM_res_id = 7600;
		
	procedure DoKeychainMenu;
		var
			junk: OSStatus;
	begin
		Assert( HasKeychainManager );
		if MKCIsKeychainUnlocked then begin
			junk := MKCLockKeychain;
		end else begin
			junk := MKCUnlockKeychain;
		end;
	end;

	procedure SetKeychainMenu (themenu, theitem: integer);
		var
			haskc: Boolean;
			locked: Boolean;
			text, name: Str255;
			junk: OSStatus;
	begin
		haskc := HasKeychainManager;
		locked := not haskc | not MKCIsKeychainUnlocked;
		if locked then begin
			GetIndString( text, kKCM_res_id, 1 );
		end else begin
			GetIndString( text, kKCM_res_id, 2 );
			junk := MKCGetKeychainName( name );
			SPrintS3( text, text, name, '', '' );
		end;
		SetIDItem( themenu, theitem, text );
		SetIDItemEnable( themenu, theitem, haskc );
	end;

	function InitKeychainMenu( var msg: integer ): OSStatus;
	begin
{$unused(msg)}
		SetFBoth('kchn', DoKeychainMenu, SetKeychainMenu);
		InitKeychainMenu := noErr;
	end;

	procedure StartupKeychainMenu;
	begin
		StartupFMenus;
		SetStartup( InitKeychainMenu, nil, 0, nil );
	end;
end.
