unit MyListWindowHeaders;

interface

	uses
		 MyListWindow;

	const
		columns_max = 7;
		columns1 = columns_max + 1;

	type
		OffsetsArray = array[1..columns1] of integer;

	const
		list_entry_align_left = teJustLeft;
		list_entry_align_right = teJustRight;
		list_entry_align_center = teJustCenter;

	type
		ListWindowHeadersObject = object(ListWindowObject)
				private_sort_column: integer;
				off: OffsetsArray;
				gap: integer;
				headerbuttons: array[1..columns1] of ControlHandle;
				headerwidths: OffsetsArray;
				hack_creating_column_button: integer;
				
				procedure CreateList (font, size: integer; columnsn: integer; ldefID: integer; hscroll: Boolean);
				override;
				procedure LDEF (message: integer; select: Boolean; const lineframe: Rect; c: Cell; dataoffset, datalen: integer);
				override;
				procedure DrawEntry( index: integer; select: Boolean; const lineframe: Rect );
				procedure MainLoopDeviceLoop(addr: Ptr; depth: integer; deviceFlags: integer; targetDevice: GDHandle; userData: univ MainLoopDeviceLoopRecordPtr);
				override;
(*
				procedure DoActivateDeactivate (activate: Boolean);
				override;
*)
				function CountEntries: longint;
				procedure DoHeaderButtonsClick (const lineframe: Rect; local: Point; const er: EventRecord );
				override;
				procedure GetHeaderMaxs (var maxs: OffsetsArray);
				procedure GetMaxs (var maxs: OffsetsArray);
				procedure Resize;
				override;
				procedure PositionHeaderButtons;
				procedure SetOffs;
				procedure SetListOffset( listoff: integer );
				override;
				procedure SetSortColumn( column: integer );
				function GetSortColumn: integer;
				procedure GetColumnRect( col: integer; var colr: Rect );
				procedure EntryInfoGetColumnRect( const lineframe: Rect; col: integer; var fullcolr, colr: Rect );
				procedure Resort;
				procedure SetEditMenuItem (item: integer);
				override;
				procedure DoEditMenu (item: integer);
				override;
				function CopySelectionToHandle: Handle;

				procedure CreateNewControl( var control: ControlHandle; const bounds: Rect; const title: string; value, min, max: SInt16; procID: SInt16 );
				procedure CreateHeaderTextButton( col: integer; const title: string; align, offset: integer );
				procedure CreateHeaderInfo;
				
				procedure DoEraseCellBackground( depth, deviceFlags: integer; const fullcolr: Rect; sortcol: Boolean );
				procedure EraseCellBackground( depth, deviceFlags: integer; const fullcolr: Rect; col: integer );
				procedure DrawBackground( const frame: Rect );
				override;
				procedure HiliteInvertCellBackground( depth, deviceFlags: integer; const fullcolr: Rect; col: integer );

				// You must override and provide
				procedure CreateHeaderButton( col: integer ); // Note that this will also be used to create the extra right hand side button
				procedure GetEntryInfo( index: integer );
				procedure EntryInfoGetColumnSize( col: integer; var width, height: integer; var align: integer );
				procedure EntryInfoDrawColumn( depth, deviceFlags: integer; const fullcolr, colr: Rect; col: integer; selected: Boolean );
					 // Note that this will also be used to draw the extra right hand column
				function EntryInfoCopyToHandle( data: Handle ): OSErr;
				function CDEF (variation: integer; control: ControlHandle; message: integer; param: longint; depth: integer; deviceFlags: integer; targetDevice: GDHandle): longint;
				override;
				function CDEFListHeaderButton ( col: integer; control: ControlHandle; message: integer; param: longInt; depth: integer; deviceFlags: integer): longint;
			end;

implementation

	uses
		MyTypes, MyUtils, MyMenus, MyListManager, MyMemory, MyMathUtils, 
		MyControls, MyWindows, MyAppearance, MySystemGlobals;

	const
		extra_column_width = 4000;
	
	type
		NonAppearanceHeaderButtonData = record
			align: longint;
			offset: longint;
		end;
		NonAppearanceHeaderButtonDataPtr = ^NonAppearanceHeaderButtonData;
		NonAppearanceHeaderButtonDataHandle = ^NonAppearanceHeaderButtonDataPtr;
		
	procedure ListWindowHeadersObject.GetEntryInfo( index: integer );
	begin
{$unused(index)}
		Assert( false );
	end;
	
	procedure ListWindowHeadersObject.EntryInfoDrawColumn( depth, deviceFlags: integer; const fullcolr, colr: Rect; col: integer; selected: Boolean );
	begin
{$unused(depth, deviceFlags, fullcolr, colr,col,selected)}
		Assert( false );
	end;

	procedure ListWindowHeadersObject.EntryInfoGetColumnSize( col: integer; var width, height: integer; var align: integer );
	begin
{$unused(col,width,height,align)}
		Assert( false );
	end;
	
	function ListWindowHeadersObject.EntryInfoCopyToHandle( data: Handle ): OSErr;
	begin
{$unused(data)}
		Assert( false );
		EntryInfoCopyToHandle := unimpErr;
	end;
	
	procedure ListWindowHeadersObject.CreateHeaderButton( col: integer );
	begin
{$unused(col)}
		Assert( false );
	end;
	
	procedure ListWindowHeadersObject.CreateNewControl( var control: ControlHandle; const bounds: Rect; const title: string; value, min, max: SInt16; procID: SInt16 );
	begin
{$ifc 0 & do_debug}
		if procID < 128 * 16 then begin
			Assert( has_Appearance );
		end else begin
			Assert( not has_Appearance );
		end;
{$endc}
		control := NewControl( window, bounds, title, true, value, min, max, procID, ord(gCallCDEFProc) );
		Assert( control <> nil );
		AddActivationControl( control );
	end;

	procedure ListWindowHeadersObject.CreateHeaderInfo;
	begin
	end;
	
	procedure ListWindowHeadersObject.CreateHeaderTextButton( col: integer; const title: string; align, offset: integer );
		var
{$ifc GENERATINGPOWERPC}
			junk: OSErr;
{$endc}
			bounds: Rect;
	begin
		SetRect( bounds, 0,  0, 100, 20 );
		if has_Appearance then begin
			CreateNewControl( headerbuttons[col], bounds, title, 0, kControlBehaviorSticky + kControlContentTextOnly, 0, 
				kControlBevelButtonSmallBevelProc + kControlUsesOwningWindowsFontVariant );
			case align of
				list_entry_align_left: align := kControlBevelButtonAlignTextFlushLeft;
				list_entry_align_right: align := kControlBevelButtonAlignTextFlushRight;
				list_entry_align_center: align := kControlBevelButtonAlignTextCenter;
				otherwise begin
					Assert( false );
				end;
			end;
{$ifc GENERATINGPOWERPC}
			junk := SetBevelButtonTextAlignment( headerbuttons[col], align, offset );
{$endc}
		end else begin
			hack_creating_column_button := col;
			CreateNewControl( headerbuttons[col], bounds, title, 0, 0, 0, 128*16 );
			hack_creating_column_button := -1;
			NonAppearanceHeaderButtonDataHandle(headerbuttons[col]^^.contrlData)^^.align := align;
			NonAppearanceHeaderButtonDataHandle(headerbuttons[col]^^.contrlData)^^.offset := offset;
		end;
		headerwidths[ col ] := offset + StringWidth( title );
		AddActivationControl( headerbuttons[col] );
	end;

	procedure ListWindowHeadersObject.DoEraseCellBackground( depth, deviceFlags: integer; const fullcolr: Rect; sortcol: Boolean );
		var
			saved: SavedGraphicsPortInfo;
	begin
		SetPort( window );		
		EnterGraphicsPort( window, saved );
		SafeSetThemeBackground( Choose( sortcol, kThemeListViewSortColumnBackgroundBrush, kThemeListViewBackgroundBrush ), 
				depth, IsDeviceLoopFlagsColour(deviceFlags) );
		EraseRect( fullcolr );
//		SafeSetThemePen( kThemeListViewSeparatorBrush, depth, IsDeviceLoopFlagsColour(deviceFlags) );
//		MoveTo( fullcolr.left, fullcolr.bottom-1 );
//		LineTo( fullcolr.right, fullcolr.bottom-1 );
		ExitGraphicsPort( saved );
	end;

	procedure ListWindowHeadersObject.EraseCellBackground( depth, deviceFlags: integer; const fullcolr: Rect; col: integer );
	begin
		DoEraseCellBackground( depth, deviceFlags, fullcolr, col = GetSortColumn );
	end;

	procedure ListWindowHeadersObject.DrawBackground( const frame: Rect );
		var
			sortcol: integer;
			sortrect: Rect;
			tempr: Rect;
	begin
		sortcol := GetSortColumn;
		if (1 <= sortcol) & (sortcol <= columns) then begin
			GetColumnRect( sortcol, sortrect );

			SafeSetThemeWindowBackground( window, kThemeListViewSortColumnBackgroundBrush, false );
			tempr := frame;
			tempr.left := sortrect.left;
			tempr.right := sortrect.right;
			EraseRect( tempr );
			SafeSetThemeWindowBackground( window, kThemeListViewBackgroundBrush, false );
			tempr := frame;
			tempr.right := sortrect.left;
			EraseRect( tempr );
			tempr := frame;
			tempr.left := sortrect.right;
			EraseRect( tempr );
		end else begin
			EraseRect( frame );
		end;
	end;
	
	procedure ListWindowHeadersObject.HiliteInvertCellBackground( depth, deviceFlags: integer; const fullcolr: Rect; col: integer );
		var
			saved: SavedGraphicsPortInfo;
	begin
		SetPort( window );		
		EnterGraphicsPort( window, saved );
		SafeSetThemeBackground( Choose( col = GetSortColumn, kThemeListViewSortColumnBackgroundBrush, kThemeListViewBackgroundBrush ), 
				depth, IsDeviceLoopFlagsColour(deviceFlags) );
		HiliteInvertRect( fullcolr );
		ExitGraphicsPort( saved );
	end;

	procedure ListWindowHeadersObject.GetHeaderMaxs (var maxs: OffsetsArray);
	begin
		maxs := headerwidths;
	end;
	
	procedure ListWindowHeadersObject.GetMaxs (var maxs: OffsetsArray);
		var
			index, col, width, height, align: integer;
	begin
		SetPort( window );
		GetHeaderMaxs( maxs );
		for index := 1 to CountEntries do begin
			GetEntryInfo( index );
			for col := 1 to columns do begin
				EntryInfoGetColumnSize( col, width, height, align );
				maxs[col] := Max( maxs[col], width );
			end;
		end;
	end;

	procedure ListWindowHeadersObject.Resize;
	begin
		PositionHeaderButtons;
		inherited Resize;
	end;
	
	procedure ListWindowHeadersObject.PositionHeaderButtons;
		var
			col: integer;
			oldclip: RgnHandle;
			header_info, header_buttons, list_frame: Rect;
	begin
		ZeroClipRegion( oldclip );
		GetWindowRects( header_info, header_buttons, list_frame );

		for col := 1 to columns do begin
			Assert( headerbuttons[col] <> nil );
			CleanSizeControl( headerbuttons[col], off[col+1] - off[col], RectHeight( header_buttons ) );
			CleanMoveControl( headerbuttons[col], off[col] - GetListOffset - 1, header_buttons.top );
		end;
		Assert( headerbuttons[columns+1] <> nil );
		CleanSizeControl( headerbuttons[col], extra_column_width, RectHeight( header_buttons ));
		CleanMoveControl( headerbuttons[col], off[columns+1] - GetListOffset - 1, header_buttons.top );
		RestoreClipRegion( oldclip );
		
		InvalRect( header_buttons );
(*
		r.top := 0;
		r.bottom := headerbuttons[1]^^.contrlRect.bottom;
		r.left := -30000;
		r.right := 30000;
		InvalRect( r );
*)
	end;
	
	procedure ListWindowHeadersObject.SetOffs;
		var
			col: integer;
			maxs: OffsetsArray;
	begin
		GetMaxs(maxs);
		off[1] := 0;
		for col := 1 to columns do begin
			off[col + 1] := off[col] + gap + maxs[col] + gap;
		end;
		SetListWidth( off[columns + 1] - 2 );
		PositionHeaderButtons;
	end;

	procedure ListWindowHeadersObject.SetSortColumn( column: integer );
	begin
		Assert( (1 <= column) & (column <= columns) );
		if column <> private_sort_column then begin
			if private_sort_column > 0 then begin
				SetControlValue( headerbuttons[private_sort_column], 0 );
			end;
			private_sort_column := column;
			SetControlValue( headerbuttons[private_sort_column], 1 );
			Resort;
		end;
	end;
	
	function ListWindowHeadersObject.GetSortColumn: integer;
	begin
//		Assert( (1 <= private_sort_column) & (private_sort_column <= columns) );
		GetSortColumn := private_sort_column;
	end;
	
	procedure ListWindowHeadersObject.SetListOffset( listoff: integer );
	begin
		if listoff <> GetListOffset then begin
			inherited SetListOffset( listoff );
			PositionHeaderButtons;
		end;
	end;
				
	procedure ListWindowHeadersObject.GetColumnRect( col: integer; var colr: Rect );
	begin
		colr := list^^.rView;
		colr.left := list^^.rView.left - GetListOffset + off[col];
		if col <= columns then begin
			colr.right := colr.left + off[col+1] - off[col];
		end else begin
			colr.right := colr.left + extra_column_width;
		end;
	end;
	
	procedure ListWindowHeadersObject.EntryInfoGetColumnRect( const lineframe: Rect; col: integer; var fullcolr, colr: Rect );
		var
			width,height,  align: integer;
	begin
		Assert( (1 <= col) & (col <= columns+1) );
		fullcolr := lineframe;
		fullcolr.left := lineframe.left - GetListOffset + off[col];
		if col <= columns then begin
			EntryInfoGetColumnSize( col, width, height, align );
			fullcolr.right := fullcolr.left + off[col+1] - off[col];
		end else begin
			width := extra_column_width;
			height := RectHeight( fullcolr );
			align := list_entry_align_left;
			fullcolr.right := fullcolr.left + extra_column_width;
		end;
(*
		if header then begin
			ther.bottom := ther.bottom - 3;
		end;
*)
		colr := fullcolr;
		colr.top := colr.top + (RectHeight(colr) - 1 - height) div 2;
		colr.bottom := colr.top + height;
		InsetRect( colr, gap, 0 );
		case align of
			list_entry_align_left:  begin
				// do nothing
			end;
			list_entry_align_right:  begin
				colr.left := colr.right - width;
			end;
			list_entry_align_center:  begin
				colr.left := (colr.left + colr.right - width) div 2;
			end;
			otherwise begin
				Assert( false );
			end;
		end;
		colr.right := colr.left + width;
	end;

	function ListWindowHeadersObject.CountEntries: longint;
	begin
		CountEntries := LCount( list );
	end;
	
	procedure ListWindowHeadersObject.DoHeaderButtonsClick ( const lineframe: Rect; local: Point; const er: EventRecord);
		var
			part: integer;
			ctl: ControlHandle;
			col, foundcol: integer;
	begin
{$unused(lineframe,er)}
		part := FindControl( local, window, ctl );
		if part <> kControlNoPart then begin
			foundcol := -1;
			for col := 1 to columns do begin
				if ctl = headerbuttons[col] then begin
					foundcol := col;
					leave;
				end;
			end;
			if (foundcol > 0) & (foundcol <> GetSortColumn) then begin
				part := SafeHandleControlClick( ctl, local, er.modifiers );
				if part <> kControlNoPart then begin
					SetSortColumn( foundcol );
				end;
			end;
		end;
	end;

	procedure ListWindowHeadersObject.Resort;
	begin
		Assert( false );
	end;
	
	type
		MyUserData= record
			mainloopstuff: MainLoopDeviceLoopRecord;
			lineframe: Rect;
			select: Boolean;
		end;
		MyUserDataPtr = ^MyUserData;
	
	var
		gUnique: integer;
	
	procedure ListWindowHeadersObject.MainLoopDeviceLoop(addr: Ptr; depth: integer; deviceFlags: integer; targetDevice: GDHandle; userData: univ MainLoopDeviceLoopRecordPtr);
		var
			col: integer;
			fullcolr, colr: Rect;
			muserData: MyUserDataPtr;
			saved: SavedGraphicsPortInfo;
	begin
		if StripAddress( addr ) = StripAddress( @gUnique ) then begin
			muserData := MyUserDataPtr(userData);
			SetPort( window );
			DoEraseCellBackground( depth, deviceFlags, muserData^.lineframe, false );
			for col := 1 to columns + 1 do begin
				EntryInfoGetColumnRect( muserData^.lineframe, col, fullcolr, colr );
				EntryInfoDrawColumn( depth, deviceFlags, fullcolr, colr, col, muserData^.select );
			end;

			EnterGraphicsPort( window, saved );
			SafeSetThemePen( kThemeListViewSeparatorBrush, depth, IsDeviceLoopFlagsColour(deviceFlags) );
			MoveTo( muserData^.lineframe.left, muserData^.lineframe.bottom-1 );
			LineTo( muserData^.lineframe.right, muserData^.lineframe.bottom-1 );
			ExitGraphicsPort( saved );

		end else begin
			inherited MainLoopDeviceLoop( addr, depth, deviceFlags, targetDevice, userData );
		end;
	end;

	procedure ListWindowHeadersObject.DrawEntry( index: integer; select: Boolean; const lineframe: Rect );
		var
			userData: MyUserData;
	begin
		if WindowPeek(window)^.visible then begin
			SetPort(window);
			PenNormal;

			GetEntryInfo( index );
			userData.lineframe := lineframe;
			userData.select := select;		
			SafeMainDeviceLoopRect( @gUnique, lineframe, @userData, 0 );
		end;
	end;

	procedure ListWindowHeadersObject.SetEditMenuItem (item: integer);
	begin
		case item of
			EMcopy:  begin
				SetIDItemEnable(M_Edit, item, IsSelection);
			end;
			EMselectall:  begin
				SetIDItemEnable(M_Edit, item, (CountEntries > 0) & not LAllSelected( list ) );
			end;
			otherwise begin
				SetIDItemEnable(M_Edit, item, false);
			end;
		end;
	end;

	function ListWindowHeadersObject.CopySelectionToHandle: Handle;
		var
			data: Handle;
			c: Cell;
			count, total: integer;
			err, junk: OSErr;
			size: longint;
			crs: string[2];
	begin
		c.h := 0;
		c.v := 0;
		junk := MNewHandle( data, 0 );
		crs := cr;
		count := 0;
		total := 0;
		while LGetSelect(true, c, list) do begin
			size := MGetHandleSize( data );
			if size <> 0 then begin
				err := MAppendString( data, crs );
			end;
			GetEntryInfo( c.v+1 );
			err := EntryInfoCopyToHandle( data );
			if err <> noErr then begin
				MShrinkHandleSize( data, size );
			end;
			Inc(total);
			Inc(c.v);
		end;
		if total > 1 then begin
			err := MAppendString( data, crs );
		end;
		CopySelectionToHandle := data;
	end;

	procedure ListWindowHeadersObject.DoEditMenu (item: integer);
		var
			loe: longint;
			data: Handle;
	begin
		case item of
			EMcopy:  begin
				data := CopySelectionToHandle;
				loe := ZeroScrap;
				MHLock( data );
				loe := PutScrap( MGetHandleSize( data ), 'TEXT', data^ );
				MDisposeHandle( data );
			end;
			EMselectall:  begin
				LSetAllSelections( list, true );
			end;
			otherwise begin
				{ do nothing }
			end;
		end;
	end;

	procedure ListWindowHeadersObject.LDEF (message: integer; select: Boolean; const lineframe: Rect; c: Cell; dataoffset, datalen: integer);

		procedure LDDraw;
		begin
			DrawEntry( c.v + 1, select, lineframe );
{			if datalen = 0 then begin
			end;}
		end;

	begin
{$unused(dataoffset, datalen)}
		case message of
			lInitMsg: 
				;
			lDrawMsg: 
				LDDraw;
			lHiliteMsg: 
				LDDraw;
			lCloseMsg: 
				;
		end;
	end;
	
	function ListWindowHeadersObject.CDEFListHeaderButton ( col: integer; control: ControlHandle; message: integer; param: longInt; depth: integer; deviceFlags: integer): longint;
		var
			err: OSErr;
			result: longint;		{	the result to return		}
			mousePoint: Point;
			frame: Rect;
			oldmode: integer;
			data: NonAppearanceHeaderButtonDataHandle;
			whereh, sw: integer;
			pressed, active: Boolean;
	begin
{$unused(col)}
		result := 0;
		data := NonAppearanceHeaderButtonDataHandle(control^^.contrlData);

		case message of
			initCntl: begin
				control^^.contrlValue := 0;
				control^^.contrlMin := 0;
				control^^.contrlMax := 1;
				err := MNewHandle( control^^.contrlData, SizeOf( NonAppearanceHeaderButtonData ) );
				Assert( err = noErr ); 
				data := NonAppearanceHeaderButtonDataHandle(control^^.contrlData);
				data^^.align := list_entry_align_left;
				data^^.offset := 0;
			end;

			drawCntl: begin
				if control^^.contrlVis <> 0 then begin
					active := control^^.contrlHilite <> kControlInactivePart;
					pressed := (control^^.contrlValue = 1) | (control^^.contrlHilite = kControlUpButtonPart);
					frame := control^^.contrlRect;
					NonAppearanceDrawListViewHeader( frame, pressed, active, depth, deviceFlags );
					oldmode := window^.txMode;
					if not active then begin
						TextMode( grayishTextOr );
					end else if control^^.contrlHilite = kControlUpButtonPart then begin
						TextMode( srcBic );
					end else begin
						TextMode( srcOr );
					end;
					sw := StringWidth( control^^.contrlTitle );
					case data^^.align of
						list_entry_align_left: begin
							whereh := frame.left + data^^.offset;
						end;
						list_entry_align_right: begin
							whereh := frame.right - sw - data^^.offset;
						end;
						list_entry_align_center: begin
							whereh := (frame.left + frame.right - sw) div 2 + data^^.offset;
						end;
					end;
					MoveTo( whereh, frame.bottom - windowfi.descent - (RectHeight(frame) - windowfi.ascent - windowfi.descent) div 2 );
					DrawString( control^^.contrlTitle );
					TextMode( oldmode );
				end;
			end;

			testCntl:  begin
				if (control^^.contrlHilite <> kControlInactivePart) then begin
					mousePoint := Point(param);
					if PtInRect( mousePoint, control^^.contrlRect ) then begin
						result := kControlUpButtonPart;
					end;
				end;
			end;

			calcCRgns, calcCntlRgn, calcThumbRgn:  begin
				param := longint(StripAddress(Ptr(param)));
				RectRgn( RgnHandle(StripAddress(Ptr(param))), control^^.contrlRect );
			end;

			dispCntl: begin
				Assert( false ); // not allowed
				// MDisposeHandle( control^^.contrlData ); done elsewhere, must be a real handle
			end;

			otherwise begin
				// Do nothing
			end;
		end;

		CDEFListHeaderButton := result;
	end;
	
	function ListWindowHeadersObject.CDEF (variation: integer; control: ControlHandle; message: integer; param: longint; depth: integer; deviceFlags: integer; targetDevice: GDHandle): longint;
		var
			j, i: integer;
	begin
		j := -1;
		for i := 1 to columns+1 do begin
			if headerbuttons[i] = control then begin
				j := i;
				leave;
			end;
		end;
		if (j <= 0) & (hack_creating_column_button > 0) then begin
			j := hack_creating_column_button;
		end;
		if j > 0 then begin
			CDEF := CDEFListHeaderButton( j, control, message, param, depth, deviceFlags );
		end else begin
			CDEF := inherited CDEF( variation, control, message, param, depth, deviceFlags, targetDevice );
		end;
	end;

	procedure ListWindowHeadersObject.CreateList (font, size: integer; columnsn: integer; ldefID: integer; hscroll: Boolean);
		var
			col: integer;
	begin
		hack_creating_column_button := -1;
		for col := 1 to columnsn do begin
			headerbuttons[col] := nil;
		end;
		gap := 10;
		inherited CreateList(font, size, columnsn, ldefID, hscroll);
		for col := 1 to columnsn + 1 do begin
			CreateHeaderButton( col );
		end;
		CreateHeaderInfo;

		private_sort_column := -1;
	end;

end.
(*
	function ListWindowHeadersObject.EditMenuEnabled: Boolean;
	begin
		EditMenuEnabled := CountEntries > 0;
	end;
		SetRect( bounds, 0, 500, 100, 520 );
		// Probably should be kControlBehaviorSticky
		headerbuttons[1] := NewControl( window, bounds, 'Testing', true, 0, 
			kControlBehaviorToggles + kControlContentTextOnly, 0, 
			kControlBevelButtonSmallBevelProc + kControlUsesOwningWindowsFontVariant, 0 );
		Assert( headerbuttons[1] <> nil );

		headerbuttons[1] := NewControl( window, bounds, '', true, 0, 0, 100, kControlProgressBarProc, 0 );
		Assert( headerbuttons[1] <> nil );
		
	procedure ListWindowHeadersObject.CreateHeaderIconButton( col: integer; icon, icon_size: integer );
		var
			bounds: Rect;
	begin
		SetRect( bounds, col*100,  0, 100 + col*100, 20 );
		// Probably should be kControlBehaviorSticky
		headerbuttons[col] := NewControl( window, bounds, NumToStr(icon), true, 0, 
			kControlBehaviorToggles + kControlContentTextOnly, 0, 
			kControlBevelButtonSmallBevelProc + kControlUsesOwningWindowsFontVariant, 0 );
		Assert( headerbuttons[col] <> nil );
		headerwidths[ col ] := icon_size;
	end;

		headerbuttons[1] := NewControl( window, bounds, '', true, 0, 0, 100, kControlProgressBarProc, 0 );
		Assert( headerbuttons[1] <> nil );
*)

