unit MyOOMainLoop;

interface

	uses
		MyFMenus;

	const
		WT_NotMine = 'NtMe';
		WT_Generic = 'Genr';
		bad_window_id = -1;
		kAECloseAll = 'Clos';
	
	type
		ControlHandleArray = array[0..0] of ControlHandle;
		ControlHandleArrayPtr = ^ControlHandleArray;
		ControlHandleArrayHandle = ^ControlHandleArrayPtr;
		
	type
		MainLoopDeviceLoopRecord = record
			obj: WObject;
			addr: Ptr;
		end;
		MainLoopDeviceLoopRecordPtr = ^MainLoopDeviceLoopRecord;

		SCType = (SCSave, SCCancel, SCDiscard);
		WObject = object
				public
				window: DialogPtr;
				resid: integer;
				window_type: OSType;
				window_id: longint;
				growRect: Rect; { minimum/maximum Rect size (for use with grow window) }
				zoomSize: Point; { Optimum zoom size }
				zoomed: Boolean;
				unzoomed: Rect;
				draw_grow_icon: Boolean;
				is_active: Boolean;
				is_default_object: Boolean;
				close_hides_window: Boolean;
				popup_title_menu: MenuHandle;
				AppleGuideWindowType: Str31;
				onlyone: ^WObject;	{ Set onlyone^ to nil when we destroy ourselves }
				timetoclose:Boolean;
				activation_controls: ControlHandleArrayHandle;
				
				private
				th_can_accept_drag: Boolean;
				th_drag_hilited: Boolean;
				th_drag_hilite_visible: Boolean;
				th_ever_left_original_hilite_region: Boolean;
				th_drag_hilite_rgn: RgnHandle;
				th_drag_original_hilite_rgn: RgnHandle;
				th_drag_invert_rgn: RgnHandle;
				
//				public
				procedure JointCreate (id: integer);
				procedure JointDestroy;
				procedure Create (id: integer);
				procedure CreateBehind (id: integer; behind: WindowPtr);
				procedure Destroy;
				procedure GetWindowPos (data: Handle);
				procedure SetWindowPos (data: Handle; var wasvisible: Boolean);
				function SaveChangesID (alert_id: integer): integer;
				function SaveChanges: SCType;
				procedure DoClose;
{ DoClose checks modified things etc, then calls Destroy }
				function SetMenuBar: Boolean;
				procedure SetMenus;
//				function EditMenuEnabled: Boolean;
				procedure SetEditMenuItem (item: integer);
				procedure DoEditMenu (item: integer);
				function GetAESelection (var reply: AppleEvent): OSErr;
				function GetAEWindow (var windowrec: AERecord): OSErr;
				function DoMenuKey (const er: EventRecord; ch: char): longint;
				procedure CalculateRegion (var rgn: RgnHandle);
				function WaitForEvent (var er: EventRecord; sleep: longint): Boolean;
				procedure DoIdle;
				procedure DoIdleAlways;
				procedure DoDiskEvent (message: longint);
				procedure DoSuspendResume (resume: Boolean);
				procedure DoHighLevel (const er: EventRecord);
				procedure DoContent (const er: EventRecord);
				procedure DoKey (const er:EventRecord; ch: char);
				procedure DoSpecialKey (const er:EventRecord; ch: char);
				procedure DoAutoKey (const er:EventRecord; ch: char);
				procedure DoPopupTitle (choice: integer);
				function CheckPopupTitle (where: Point): Boolean;
				procedure DoDrag (where: Point);
				procedure DoGrow (where: Point);
				procedure Zoom (zoomout: Boolean; fullscreen: Boolean);
				procedure DoZoom (where: Point; code: integer);
				procedure DoGoAway (where: Point);
				procedure DoUpdate;
				procedure DoMouseMoved (where: Point);
				procedure DrawGrow;
				procedure AddActivationControl( control: ControlHandle );
				procedure RemoveActivationControl( control: ControlHandle );
				procedure DoActivateDeactivate (activate: Boolean);
				procedure TextChanged; { called for paste/clear/cut/key down etc }
				procedure Resize;
				procedure InitialZoom (h, v: integer);
				procedure Draw;
				procedure TrackingRemoveHiliting(dragref: DragReference); { must be idenpotent }
				procedure MyShowDragHilite( dragref: DragReference; hilitergn: RgnHandle );
				procedure MyHideDragHilite( dragref: DragReference; hilitergn: RgnHandle );
				function TrackingHandler (message: DragTrackingMessage; dragref: DragReference): OSErr;
				function MyTrackingEnterWindow( dragref: DragReference ): Boolean;
				procedure MyTrackingLeaveWindow( dragref: DragReference );
				procedure MyTrackingInWindow( dragref: DragReference; localwhere: Point; var new_drag_hilited: Boolean; new_drag_hilite_rgn, new_drag_invert_rgn: RgnHandle );
				function ReceiveHandler (dragref: DragReference): OSErr;
				function DragSend (flavor: FlavorType; item: ItemReference; dragref: DragReference): OSErr;
				function DoSetupDrag (dragref: DragReference; dragrgn: RgnHandle): OSErr;
				procedure DoTrackDrag (const er: EventRecord);
				function DoMainClick (const er: EventRecord; wp: WindowPtr; code: integer): Boolean;
				function DoIsDialogEventVar (var er: EventRecord): Boolean;
				function DoDialogSelectVar (var er: EventRecord; var dlg: DialogPtr; var item: integer): Boolean;
				function HandleSimpleEvents (var er: EventRecord): Boolean;
				function HandleEvents (var er: EventRecord): Boolean;
				procedure MainLoopDeviceLoop( addr: Ptr; depth: integer; deviceFlags: integer; targetDevice: GDHandle; userData: univ MainLoopDeviceLoopRecordPtr );
				procedure SafeMainDeviceLoop( addr: Ptr; drawingRgn: RgnHandle; userData: univ MainLoopDeviceLoopRecordPtr; flags: DeviceLoopFlags );
				procedure SafeMainDeviceLoopRect( addr: Ptr; drawingRect: Rect; userData: univ MainLoopDeviceLoopRecordPtr; flags: DeviceLoopFlags );
				procedure LDEF (message: integer; select: Boolean; const lineframe: Rect; c: Cell; dataOffset, dataLen: integer);
				function CDEF (variation: integer; control: ControlHandle; message: integer; param: longint; depth: integer; deviceFlags: integer; targetDevice: GDHandle): longint;
			end;
		DObject = object(WObject)
				public
				ok_item, cancel_item, outline_item: integer;
				disable_edit_menu: Boolean;
				text_return: Boolean;
				support_edittext_draging_send: Boolean;
				support_edittext_draging_receive: Boolean;
				procedure Create (id: integer);
				override;
				procedure CreateBehind (id: integer; behind: WindowPtr);
				override;
				procedure Destroy;
				override;
				procedure SetOOOutline (def_item, user_item: integer);
				procedure DrawOutline( foreground: Boolean );
				procedure DrawUserItem( item: integer );
				procedure HandleUserItem( item: integer );
				procedure HandleAllUserItems;
				procedure DoActivateDeactivate (activate: Boolean);
				override;
				function HandleEvents (var er: EventRecord): Boolean;
				override;
				procedure DoItem (item: integer);
				procedure DoItemWhere (const er: EventRecord; item: integer);
				procedure DoCancel (const er:EventRecord; ch: char);
				procedure DoOK (const er:EventRecord; ch: char);
				procedure DoTab( const er:EventRecord; backwards: Boolean );
				procedure DoDialogCut;
				procedure DoDialogCopy;
				procedure DoDialogPaste;
				procedure DoDialogDelete;
				procedure SetEditMenuItem (item: integer);
				override;
//				function EditMenuEnabled: Boolean;
//				override;
				procedure DoEditMenu (item: integer);
				override;
				function DoIsDialogEventVar(var er: EventRecord): Boolean;
				override;
				function GetAESelection (var reply: AppleEvent): OSErr;
				override;
				procedure CalculateRegion (var rgn: RgnHandle);
				override;
				procedure InsertTextAndSelect( field: integer; offset: integer; data: Str255 );
				function MyTrackingEnterWindow( dragref: DragReference ): Boolean;
				override;
				procedure MyTrackingLeaveWindow( dragref: DragReference );
				override;
				procedure MyTrackingInWindow( dragref: DragReference; localwhere: Point; var new_drag_hilited: Boolean; new_drag_hilite_rgn, new_drag_invert_rgn: RgnHandle );
				override;
				function ReceiveHandler(dragref: DragReference): OSErr;
				override;
			end;

	type
		MenuNumber = integer;
		MenuNumberArray = array[0..0] of MenuNumber;
		MenuNumberPtr = ^MenuNumberArray;
		MenuNumberHandle = ^MenuNumberPtr;
	var
		default_object: WObject;
		last_event_time: longint;
		last_event: EventRecord;
		last_event_had_option: Boolean;
		last_event_had_command: Boolean;
		last_event_had_shift: Boolean;
		last_event_had_control: Boolean;
		has_DragManager: Boolean;
		gCallLDEFProc : UniversalProcPtr;
		gCallCDEFProc : UniversalProcPtr;

	procedure StartupMainLoop;
	procedure ConfigureMainLoop (dobj: DObject);
{ dobj will be used returned with window set to wp whenever GetWObject/GetDObject is called with a DA or nil window }
	function GetWType (wp: WindowPtr): OSType;
	function GetWObject (wp: WindowPtr): WObject;
	function GetDObject (dlg: DialogPtr): DObject;
	function FrontObject: WObject;
	function IsWObjectFront (o: WObject): Boolean;
	function FindWindowID (id: longint): WObject;
	procedure DoCloseAll (all: Boolean);
{	procedure CallIdleAlways;}
	procedure AppendToHandleMenuEnabled( menu: MenuNumber );

implementation

	uses
		MyStartup, MyStrings, MyAssertions, 
		MyMenus, MyTypes, BaseGlobals, MySystemGlobals, MyCursors,MyCallProc, MyEvents, MyControls, 
		MyCleverAlerts, MyTEUtils, MyAssertions, MyDialogs, MyAEUtils, MyWindows, MyMathUtils, 
		MyDrag, MyLowLevel, MyUtils, MyTextEdit, MyRegions, MyMemory, MyStrings;

	const
		titlebar_hight = 18;

	const
{ from EPPC }
		OOMagic = 'MyOO';
		BadOOMagic = 'bado';

	type
		myWindowRecord = record
				thewindow: WindowRecord;
				magic: OSType;
			end;
		myWindowPtr = ^myWindowRecord;
		myDialogRecord = record
				thedialog: DialogRecord;
				magic: OSType;
			end;
		myDialogPtr = ^myDialogRecord;

{$ifc do_debug}
	var
		startup_check: integer;
{$endc}

	var
		last_window_id: longint;
		gMyDragSendProc : UniversalProcPtr;
		gDrawUserItemProc: UniversalProcPtr;
		gMainLoopDeviceLoopProc: UniversalProcPtr;
		gCDEFDeviceLoopProc: UniversalProcPtr;
		gHandleMenuEnabled: MenuNumberHandle;

	procedure DoCloses (all: Boolean);
		var
			fw: WindowPtr;
	begin
		if all then begin
			fw := FrontWindow;
			while fw <> nil do begin
				FrontObject.DoClose;
				if fw = FrontWindow then begin
					leave;
				end;
				fw := FrontWindow;
			end;
		end else begin
			FrontObject.DoClose;
		end;
	end;

	function HandleClose (var event, reply: AppleEvent; refcon: UInt32): OSErr;
		var
			err: OSErr;
	begin
{$unused(event, reply)}
		if FrontWindow <> nil then begin
			DoCloses(refcon <> 0);
			err := noErr;
		end else begin
			err := errAENoSuchObject;
		end;
		HandleClose := err;
	end;

	procedure DoCloseAll (all: Boolean);
	begin
		if has_AppleEvents then begin
			if all then begin
				SendSelfSimpleEvent(kAECoreSuite, kAECloseAll);
			end else begin
				SendSelfSimpleEvent(kAECoreSuite, kAEClose);
			end;
		end else begin
			DoCloses(all);
		end;
	end;

	function GetWRC (wp: WindowPtr): WObject;
		var
			rc: longint;
	begin
		rc := 0;
		if (wp <> nil) & WindowInWindowList(wp) & (WindowPeek(wp)^.windowKind >= 0) then begin
			if ((WindowPeek(wp)^.windowKind = dialogKind) & (myDialogPtr(wp)^.magic = OOMagic)) | (myWindowPtr(wp)^.magic = OOMagic) then begin
				rc := GetWRefCon(wp);
			end;
		end;
		if rc = 0 then begin
			default_object.window := wp;
			rc := longint(default_object);
		end;
		GetWRC := WObject(rc);
	end;

	function GetWType (wp: WindowPtr): OSType;
		var
			wo: WObject;
	begin
		wo := GetWRC(wp);
		if wo.is_default_object then begin
			GetWType := WT_NotMine;
		end else begin
			GetWType := wo.window_type;
		end;
	end;

	function GetWObject (wp: WindowPtr): WObject;
	begin
		GetWObject := GetWRC(wp);
	end;

	function FindWindowID (id: longint): WObject;
		const
			WindowList = $9D6;
		type
			WindowPtrPtr = ^WindowPtr;
		var
			w: WindowPtr;
			wo: WObject;
	begin
		FindWindowID := nil;
		if id <> bad_window_id then begin
			w := WindowPtrPtr(WindowList)^;
			while w <> nil do begin
				wo := GetWObject(w);
				if (not wo.is_default_object) & (wo.window_id = id) then begin
					FindWindowID := wo;
					leave;
				end;
				w := WindowPtr(WindowPeek(w)^.nextWindow);
			end;
		end;
	end;

	function GetDObject (dlg: DialogPtr): DObject;
	begin
		GetDObject := DObject(GetWRC(dlg));
	end;

	function FrontObject: WObject;
	begin
		FrontObject := GetWRC(FrontWindow);
	end;

	function IsWObjectFront (o: WObject): Boolean;
	begin
		if o = nil then begin
			IsWObjectFront := false;
		end else if o.window = nil then begin
			IsWObjectFront := false;
		end else begin
			IsWObjectFront := o.window = FrontWindow;
		end;
	end;

	function WObject.MyTrackingEnterWindow( dragref: DragReference ): Boolean;
	begin
{$unused(dragref)}
		MyTrackingEnterWindow := false;
	end;

	procedure WObject.MyTrackingLeaveWindow( dragref: DragReference );
	begin
{$unused(dragref)}
	end;

	procedure WObject.MyTrackingInWindow( dragref: DragReference; localwhere: Point; var new_drag_hilited: Boolean; new_drag_hilite_rgn, new_drag_invert_rgn: RgnHandle );
	begin
{$unused(dragref, localwhere, new_drag_hilited, new_drag_hilite_rgn, new_drag_invert_rgn)}
		new_drag_hilited := false;
	end;

	procedure WObject.TrackingRemoveHiliting( dragref: DragReference ); { must be idenpotent }
	begin
		if th_drag_hilite_visible then begin
			MyHideDragHilite( dragref, th_drag_hilite_rgn );
			th_drag_hilite_visible := false;
		end;
		if th_drag_hilited then begin
			InvertRgn( th_drag_invert_rgn );
			MakeRegionEmpty( th_drag_invert_rgn );
			th_drag_hilited := false;
		end;
	end;

	procedure WObject.MyShowDragHilite( dragref: DragReference; hilitergn: RgnHandle );
		var
			junk: OSErr;
	begin
		junk := ShowDragHilite( dragref, hilitergn, true );
	end;

	procedure WObject.MyHideDragHilite( dragref: DragReference; hilitergn: RgnHandle );
		var
			junk: OSErr;
	begin
{$unused(hilitergn)}
		junk := HideDragHilite( dragref );
	end;

	function WObject.TrackingHandler (message: DragTrackingMessage; dragref: DragReference): OSErr;
		var
			mouse, pinnedmouse: Point;
			attributes: DragAttributes;
			new_drag_hilited, new_drag_hilite_visible: Boolean;
			new_drag_hilite_rgn, new_drag_invert_rgn: RgnHandle;
			err: OSErr;
			has_left_sender_window, in_sender_window: Boolean;
	begin
		SetPort(window);
		err := GetDragAttributes(dragref, attributes);
		in_sender_window := (band(attributes, kDragInsideSenderWindow) <> 0);
		has_left_sender_window := (band(attributes, kDragHasLeftSenderWindow) <> 0);
		if err = noErr then begin
			case message of
				kDragTrackingEnterHandler, kDragTrackingLeaveHandler: 
					;  { WE DONT GET THESE! }
				kDragTrackingEnterWindow:  begin
					th_drag_hilited := false;
					th_drag_hilite_visible := false;
					th_drag_hilite_rgn := MNewRgn;
					th_drag_invert_rgn := MNewRgn;
					th_drag_original_hilite_rgn := MNewRgn;
					th_can_accept_drag := MyTrackingEnterWindow( dragref );
					if in_sender_window & (GetDragOrigin( dragref, mouse ) = noErr) then begin
						GlobalToLocal( mouse );
						MyTrackingInWindow( dragref, mouse, new_drag_hilited, th_drag_original_hilite_rgn, th_drag_invert_rgn );
						SetEmptyRgn( th_drag_invert_rgn );
						if not new_drag_hilited then begin
							SetEmptyRgn( th_drag_original_hilite_rgn );
						end;
					end;
					th_ever_left_original_hilite_region := EmptyRgn( th_drag_original_hilite_rgn );
				end;
				kDragTrackingInWindow:  begin
					if th_can_accept_drag then begin
						err := GetDragMouse(dragref, mouse, pinnedmouse);
						GlobalToLocal(mouse);

						if not th_ever_left_original_hilite_region then begin
							th_ever_left_original_hilite_region := has_left_sender_window | not PtInRgn( mouse, th_drag_original_hilite_rgn );
						end;

						new_drag_hilite_rgn := MNewRgn;
						new_drag_invert_rgn := MNewRgn;
						MyTrackingInWindow( dragref, mouse, new_drag_hilited, new_drag_hilite_rgn, new_drag_invert_rgn );
						new_drag_hilite_visible := new_drag_hilited and th_ever_left_original_hilite_region;
						if not new_drag_hilited then begin
							SetEmptyRgn( new_drag_invert_rgn );
						end;
						if not new_drag_hilite_visible then begin
							SetEmptyRgn( new_drag_hilite_rgn );
						end;

						{ update the hilite region }
						if (new_drag_hilite_visible <> th_drag_hilite_visible) | not EqualRgn( new_drag_hilite_rgn, th_drag_hilite_rgn ) then begin
							if th_drag_hilite_visible then begin
								MyHideDragHilite(dragref, th_drag_hilite_rgn);
							end;
							if new_drag_hilite_visible then begin
								MyShowDragHilite(dragref, new_drag_hilite_rgn);
							end;
							MDisposeRgn( th_drag_hilite_rgn );
							th_drag_hilite_rgn := new_drag_hilite_rgn;
						end else begin
							MDisposeRgn( new_drag_hilite_rgn );
						end;

						{ update the invert region }
						if not EqualRgn( new_drag_invert_rgn, th_drag_invert_rgn ) then begin
							XorRgn( new_drag_invert_rgn, th_drag_invert_rgn, new_drag_invert_rgn ); { invert them both }
							InvertRgn( new_drag_invert_rgn );
							XorRgn( new_drag_invert_rgn, th_drag_invert_rgn, new_drag_invert_rgn ); { remove old }
							MDisposeRgn( th_drag_invert_rgn );
							th_drag_invert_rgn := new_drag_invert_rgn;
						end else begin
							MDisposeRgn( new_drag_invert_rgn );
						end;

						th_drag_hilited := new_drag_hilited;
						th_drag_hilite_visible := new_drag_hilite_visible;
					end;
				end;
				kDragTrackingLeaveWindow:  begin
					TrackingRemoveHiliting( dragref );
					MyTrackingLeaveWindow( dragref );
					th_can_accept_drag := false;
					MDisposeRgn( th_drag_hilite_rgn );
					MDisposeRgn( th_drag_invert_rgn );
					MDisposeRgn( th_drag_original_hilite_rgn );
				end;
				otherwise begin
					{ do nothing }
				end;
			end;
		end;
		TrackingHandler := err;
	end;

	function MyTrackingHandler (message: DragTrackingMessage; window: WindowPtr; refcon: Ptr; dragref: DragReference): OSErr;
	begin
{$unused(refcon)}
		MyTrackingHandler := GetWObject(window).TrackingHandler(message, dragref);
	end;

	function WObject.ReceiveHandler (dragref: DragReference): OSErr;
	begin
{$unused(dragref)}
		ReceiveHandler := -17026;
	end;

	function MyReceiveHandler (window: WindowPtr; refcon: Ptr; dragref: DragReference): OSErr;
	begin
{$unused(refcon)}
		MyReceiveHandler := GetWObject(window).ReceiveHandler(dragref);
	end;

	function WObject.DragSend (flavor: FlavorType; item: ItemReference; dragref: DragReference): OSErr;
	begin
{$unused(flavor, item, dragref)}
		DragSend := -17027;
	end;

	var
		drag_obj: WObject;

	function MyDragSend (flavor: FlavorType; refcon: Ptr; item: ItemReference; dragref: DragReference): OSErr;
	begin
{$unused(refcon)}
		MyDragSend := drag_obj.DragSend(flavor, item, dragref);
	end;

	function WObject.DoSetupDrag (dragref: DragReference; dragrgn: RgnHandle): OSErr;
	begin
{$unused(dragref, dragrgn)}
		DoSetupDrag := -17028;
	end;

	procedure WObject.DoTrackDrag (const er: EventRecord);
		var
			err: OSErr;
			dragref: DragReference;
			dragrgn: RgnHandle;
	begin
		InitCursor;
		drag_obj := self;
		err := NewDrag(dragref);
		if err = noErr then begin
			dragrgn := MNewRgn;
			err := MemError;
			if err = noErr then begin
				err := DoSetupDrag(dragref, dragrgn);
				if err = noErr then begin
					err := SetDragSendProc(dragref, gMyDragSendProc, nil);
				end;
				if err = noErr then begin
					CursorSetProcessing(false);
					err := TrackDrag(dragref, er, dragrgn);
				end;
				MDisposeRgn(dragrgn);
			end;
			err := DisposeDrag(dragref);
		end;
	end;

	function WObject.SaveChangesID (alert_id: integer): integer;
		var
			a: integer;
			title, ing: Str255;
	begin
		SelectWindow(window);
		GetWTitle(window, title);
		if quitNow then begin
			ing := GetGlobalStr( GS_Quiting );
		end else begin
			ing := GetGlobalStr( GS_Closing );
		end;
		CleverParamText(title, ing, '', '');
		a := CleverAlert(alert_id);
		SaveChangesID := a;
	end;

	function WObject.SaveChanges: SCType;
	begin
		SaveChanges := SCType(SaveChangesID(save_changes_alert_id) - 1);
	end;
(*
	function WObject.EditMenuEnabled: Boolean;
	begin
		if window = nil then begin
			EditMenuEnabled := false;
		end else begin
			EditMenuEnabled := WindowPeek(window)^.windowKind < 0;
		end;
	end;
*)
	function WObject.SetMenuBar: Boolean;
		var
			changed: Boolean;
		procedure UpdateMenuEnable( menu: integer; on: Boolean );
			var
				old: Boolean;
		begin
			old := GetIDItemEnable( menu, 0 );
			if old <> on then begin
				changed := true;
				SetIDItemEnable( menu, 0, on );
			end;
		end;
		var
			i, menu: integer;
	begin
		changed := false;
		Assert( gHandleMenuEnabled <> nil );
		if gHandleMenuEnabled <> nil then begin
			for i := 0 to MGetHandleSize( gHandleMenuEnabled ) div SizeOf(MenuNumber) - 1 do begin
				menu := gHandleMenuEnabled^^[i];
				SetFMenu( menu );
				UpdateMenuEnable( menu, AnyIDItemEnabled( menu ) );
			end;
//		end else if not edit_menu_always_enabled then begin
//			SetFMenu( M_Edit );
//			UpdateMenuEnable( M_Edit, AnyIDItemEnabled( M_Edit ) );
//			UpdateMenuEnable( M_Edit, FrontObject.EditMenuEnabled );
		end;
		SetMenuBar := changed;
	end;

	procedure WObject.SetMenus;
	begin
		SetFMenus;
	end;

	procedure WObject.SetEditMenuItem (item: integer);
	begin
//		if not EditMenuEnabled then begin
		SetIDItemEnable(M_Edit, item, false);
//		end;
	end;

	procedure WObject.DoEditMenu (item: integer);
		var
			dummyb: Boolean;
	begin
		if item <= 6 then begin
			dummyb := SystemEdit(item - 1);
		end;
	end;

	function WObject.GetAESelection (var reply: AppleEvent): OSErr;
	begin
{$unused(reply)}
		GetAESelection := errAENoUserSelection;
	end;

	function WObject.GetAEWindow (var windowrec: AERecord): OSErr;
		var
			err, junk: OSErr;
			s: Str255;
			r: Rect;
	begin
		AECreate(windowrec);
		if is_default_object then begin
			err := errAEDescNotFound;
		end else begin
			err := AECreateList(nil, 0, true, windowrec);
			GetWTitle(window, s);
			if err = noErr then begin
				junk := PutStringToAERecord(windowrec, pName, s);
				r := window^.portRect;
				SetPort(window);
				LocalToGlobal(r.topLeft);
				LocalToGlobal(r.botRight);
				junk := AEPutParamPtr(windowrec, keyAEBounds, typeQDRectangle, @r, SizeOf(r));
				junk := AEPutParamPtr(windowrec, keyAEPosition, typeQDPoint, @r.topLeft, SizeOf(r.topLeft));
			end;
		end;
		GetAEWindow := err;
	end;

	function WObject.DoMenuKey (const er: EventRecord; ch: char): longint;
	begin
{$unused(ch)}
		DoMenuKey := DoFMenuKey(er);
	end;

	procedure WObject.CalculateRegion (var rgn: RgnHandle);
	begin
		CursorSetArrow;
		rgn := nil;
	end;

	function WObject.WaitForEvent (var er: EventRecord; sleep: longint): Boolean;
		var
			rgn: RgnHandle;
	begin
		rgn := nil;
		if is_default_object | (GetWType(window) = WT_NotMine) | IsWindowShaded(window) then begin
			CursorSetArrow;
		end else begin
			CalculateRegion(rgn);
		end;
		CursorSetProcessing(false);
		WaitForEvent := WaitNextEvent(everyEvent, er, sleep, rgn);
		if rgn <> nil then begin
			MDisposeRgn(rgn);
		end;
	end;

	procedure WObject.DoDiskEvent (message: longint);
		var
			pt: Point;
			oe: OSErr;
	begin
		if (HiWord(message) <> noErr) then begin
			with GetQDGlobals^.screenBits.bounds do begin
				pt.h := (right - left - 304) div 2;
				pt.v := (bottom - top - 156) div 3;
			end;
			CursorSetArrow;
			CursorSetProcessing(false);
			oe := DIBadMount(pt, message);
		end;
	end;

	procedure WObject.DoSuspendResume (resume: Boolean);
	begin
		SetInForeground(resume);
		if FrontWindow <> nil then begin
			FrontObject.DoActivateDeactivate(resume);
		end;
		CursorSetArrow;
	end;

	procedure WObject.DoHighLevel (const er: EventRecord);
		var
			oe: OSErr;
	begin
		if has_AppleEvents then begin
			oe := AEProcessAppleEvent(er);
		end;
	end;

	procedure WObject.JointCreate (id: integer); { Called for DefaultObject and for default_object too! }
	begin
		AssertDidStartup( startup_check );
		MLockObjHigh( self );
		popup_title_menu := nil;
		AppleGuideWindowType := '';
		if window <> nil then begin
			SetWRefCon(window, ord4(self));
			GetWindowRect(window, unzoomed);
		end;
		zoomed := false;
		close_hides_window := false;
		SetRect(growRect, 63, 61, 25000, 25000);
		zoomSize.h := 30000;
		zoomSize.v := 30000;
		window_type := WT_Generic;
		draw_grow_icon := false;
		window_id := last_window_id;
		last_window_id := last_window_id + 1;
		resid := id;
		is_default_object := false;
		onlyone := nil;
		timetoclose:=false;
		activation_controls := nil;
	end;

	procedure WObject.CreateBehind (id: integer; behind: WindowPtr);
		var
			wp: myWindowPtr;
			junk: OSErr;
	begin
		junk := MNewPtr( wp, SizeOf(myWindowRecord) );
		wp^.magic := OOMagic;

		window := GetNewCWindow(id, Ptr(wp), behind);
//		if GetResource( 'wctb', id ) <> nil then begin
//		end else begin
//			window := GetNewWindow(id, Ptr(wp), behind);
//		end;
		Assert( window <> nil );
		Assert( WindowPtr(wp) = window );
		JointCreate(id);
	end;

	procedure WObject.Create (id: integer);
	begin
		CreateBehind(id, window_at_front);
	end;

	procedure WObject.JointDestroy;
	begin
		MDisposePtr( window );
		if onlyone <> nil then begin
			onlyone^ := nil;
		end;
		MDisposeHandle( activation_controls );
		MDisposeObject( self );
	end;
	
	procedure WObject.Destroy;
	begin
		if (window <> nil) & (GetWType(window) <> WT_NotMine) then begin
			CloseWindow( window ); // may call CDEF/LDEF disposes
			myWindowPtr(window)^.magic := BadOOMagic;
			JointDestroy;
		end;
	end;

{$PUSH}
{$ALIGN MAC68K}

	type
		savedWindowRecord = record
				windowpos: Rect; { the window position }
				windowvis: Rect; { the visible part of the title bar }
				zoomed: Boolean;
				visible: Boolean;
			end;
		savedWindowPtr = ^savedWindowRecord;
		savedWindowHandle = ^savedWindowPtr;

{$ALIGN RESET}
{$POP}

	procedure WObject.GetWindowPos (data: Handle);
		var
			err: OSErr;
			rgn: RgnHandle;
			r1, r2, global_portrect: Rect;
	begin
		MHUnlock(data);
		err := MSetHandleSize( data, SizeOf(savedWindowRecord) );
		Assert( err = noErr );
		MHLock(data);
		with savedWindowHandle(data)^^ do begin
			SetPort(window);
			visible := WindowPeek(window)^.visible;
			GetWindowPortRect(window, global_portrect);
			LocalToGlobal(global_portrect.topLeft);
			LocalToGlobal(global_portrect.botRight);
			windowpos := global_portrect;
			windowpos.top := windowpos.top - titlebar_hight; { title bar }
			rgn := MNewRgn;
			RectRgn(rgn, windowpos);
			SectRgn(GetGrayRgn, rgn, rgn);
			windowvis := rgn^^.rgnBBox;
			MDisposeRgn(rgn);
			r1 := global_portrect;
			GetWindowStandardState(window, r2);
			InsetRect(r1, -7, -7);
			zoomed := PtInRect(r2.topLeft, r1) and PtInRect(r2.botRight, r1);
		end;
		MHUnlock(data);
	end;

	procedure WObject.SetWindowPos (data: Handle; var wasvisible: Boolean);
		var
			rgn: RgnHandle;
			r: Rect;
			dummy: Boolean;
	begin
		if (data <> nil) & (MGetHandleSize(data) = SizeOf(savedWindowRecord)) then begin
			MHLock(data);
			with savedWindowHandle(data)^^ do begin
				wasvisible := visible;
				rgn := MNewRgn;
				RectRgn(rgn, windowvis);
				SectRgn(GetGrayRgn, rgn, rgn);
				r := rgn^^.rgnBBox;
				MDisposeRgn(rgn);
				dummy := SectRect(r, windowvis, r);
				if (longint(r.topLeft) = longint(windowvis.topLeft)) & (longint(r.botRight) = longint(windowvis.botRight)) then begin
					with windowpos do begin
						MoveWindow(window, left, top + titlebar_hight, true);
						SizeWindow(window, right - left, bottom - top - titlebar_hight, true);
					end;
				end;
				if zoomed then begin
					Zoom(true, false);
				end else begin
					Resize;
				end;
			end;
			MHUnlock(data);
		end else
			wasvisible := true;
	end;

	procedure WObject.DoClose;
	begin
		if close_hides_window then begin
			HideWindow(window);
		end else begin
			Destroy;
		end;
	end;

	procedure WObject.DoContent (const er: EventRecord);
	begin
{$unused(er)}
	end;

	procedure WObject.DoKey (const er:EventRecord; ch: char);
	begin
{$unused(er, ch)}
		SysBeep(1);
	end;

	procedure WObject.DoSpecialKey (const er:EventRecord; ch: char);
		var
			item: integer;
	begin
		item := -1;
		case EventKeyCode( er ) of
			undoKeyCode: 
				item := EMundo;
			cutKeyCode: 
				item := EMcut;
			copyKeyCode: 
				item := EMcopy;
			pasteKeyCode: 
				item := EMpaste;
			clearKeyCode: 
				item := EMclear;
			otherwise begin
				{ do nothing }
			end;
		end;
		if item <> -1 then begin
			SetMenus;
			if not GetIDItemEnable(M_Edit, 0) or not GetIDItemEnable(M_Edit, item) then begin
				item := -1;
			end;
		end;
		if item = -1 then begin
{			if not EventHasCommandKey( er ) then begin}
				DoKey(er, ch);
{			end;}
		end else begin
			DoFMenu(M_Edit, item);
		end;
	end;

	procedure WObject.DoAutoKey (const er:EventRecord; ch: char);
	begin
		DoKey(er, ch);
	end;

	procedure WObject.DoDrag (where: Point);
		var
			temprect: Rect;
	begin
		SetPort(window);
		temprect := GetGrayRgn^^.rgnBBox;
		DragWindow(window, where, temprect);
	end;

	procedure WObject.DoGrow (where: Point);
		var
			mypt: Point;
			oldrect: Rect;
			mResult: longint;
			tempRect: Rect;
	begin
		SetPort(window);
		mypt := where;
		GlobalToLocal(mypt);
		GetWindowPortRect(window, oldrect);
		mResult := GrowWindow(window, where, growRect);
		SizeWindow(window, LoWord(mResult), HiWord(mResult), TRUE);
		SetRect(tempRect, 0, mypt.v - 15, mypt.h + 15, mypt.v + 15);
		EraseRect(tempRect);
		InvalRect(tempRect);
		SetRect(tempRect, mypt.h - 15, 0, mypt.h + 15, mypt.v + 15);
		EraseRect(tempRect);
		InvalRect(tempRect);
		zoomed := false;
		Resize;
	end;

	procedure WObject.Zoom (zoomout: Boolean; fullscreen: Boolean);
		var
			zoompt: Point;
	begin
		if fullscreen then begin
			SetPt(zoompt, 30000, 30000);
		end else begin
			zoompt := zoomSize;
		end;
		zoompt.h := Max(zoompt.h, growRect.left);
		zoompt.v := Max(zoompt.v, growRect.top);
		ZoomTheWindow(window, zoomout, zoompt, unzoomed);
		Resize;
		zoomed := zoomout;
	end;

	procedure WObject.DoZoom (where: Point; code: integer);
	begin
		SetPort(window);
		if TrackBox(window, where, code) then begin
			Zoom(not zoomed, last_event_had_option);
		end;
	end;

	procedure WObject.InitialZoom (h, v: integer);
		var
			old: Point;
	begin
		Resize;
		old := zoomSize;
		if h <> 0 then begin
			zoomSize.h := h;
		end;
		if v <> 0 then begin
			zoomSize.v := v;
		end;
		Zoom(true, false);
		zoomSize := old;
		zoomed := false;
		GetWindowRect(window, unzoomed);
	end;

	procedure WObject.DoGoAway (where: Point);
	begin
		if TrackGoAway(window, where) then begin
			DoCloseAll(last_event_had_option);
		end;
	end;

	procedure WObject.DoUpdate;
	begin
		BeginUpdate(window);
		Draw;
		EndUpdate(window);
	end;

	procedure WObject.TextChanged;
	begin
	end;

	procedure WObject.DoMouseMoved (where: Point);
	begin
{$unused(where)}
	end;

	procedure WObject.DrawGrow;
	begin
		DrawGrowIcon(window);
	end;

	procedure WObject.AddActivationControl( control: ControlHandle );
		var
			err: OSErr;
	begin
		if activation_controls = nil then begin
			err := MNewHandle( activation_controls, 0 );
			Assert( err = noErr );
		end;
		Assert( activation_controls <> nil );
		err := MAppendToHandle( activation_controls, @control, SizeOf(ControlHandle) );
	end;
	
	procedure WObject.RemoveActivationControl( control: ControlHandle );
		var
			i: integer;
	begin
		Assert( activation_controls <> nil );
		for i := 0 to MGetHandleSize( activation_controls ) div SizeOf(ControlHandle) - 1 do begin
			if control = activation_controls^^[i] then begin
				MMungerDelete( activation_controls, i * SizeOf(ControlHandle), SizeOf(ControlHandle) );
				return;
			end;
		end;
		Assert( false );
	end;
	
	procedure WObject.DoActivateDeactivate (activate: Boolean);
		var
			i: integer;
	begin
		Assert(window <> nil);
		is_active := activate and WindowPeek(window)^.visible;
		if is_active then begin
			SelectWindow(window);
		end;
		if activation_controls <> nil then begin
			for i := 0 to MGetHandleSize( activation_controls ) div SizeOf(ControlHandle) - 1 do begin
				SetControlEnable( activation_controls^^[i], activate );
			end;
		end;
		if draw_grow_icon then begin
			DrawGrow;
		end;
	end;

	procedure WObject.Resize;
	begin
		if draw_grow_icon then begin
			DrawGrow;
		end;
	end;

	procedure WObject.Draw;
	begin
		if draw_grow_icon then begin
			DrawGrow;
		end;
	end;

	function WObject.DoIsDialogEventVar(var er: EventRecord): Boolean;
	begin
		if (( er.what = keyDown ) | ( er.what = autoKey )) 
				& ( EventKeyCode( er ) in [undoKeyCode, cutKeyCode, copyKeyCode, pasteKeyCode, clearKeyCode] ) then begin
			DoIsDialogEventVar := false;
		end else begin
			DoIsDialogEventVar := IsDialogEvent(er);
		end;
	end;

	function WObject.DoDialogSelectVar (var er: EventRecord; var dlg: DialogPtr; var item: integer): Boolean;
		var
			dummy: Boolean;
			localwhere: Point;
	begin
		dummy := DialogSelect(er, dlg, item);
		if not dummy & (er.what = mouseDown) & has_Appearance & (system_version < $08500000) then begin
// Appearance pre 8.5 did not handle clicks on statText items
			SetPort( dlg );
			localwhere := er.where;
			GlobalToLocal( localwhere );
			dummy := PointOverEnabledStaticTextItem( dlg, localwhere, item );
		end;
		DoDialogSelectVar := dummy;
	end;

	procedure WObject.DoIdle;
	begin
	end;

	procedure WObject.DoIdleAlways;
	begin
	end;

	procedure WObject.DoPopupTitle (choice: integer);
	begin
{$unused(choice)}
	end;

	function WObject.CheckPopupTitle (where: Point): Boolean;
		var
			result: longint;
			center, width: integer;
			saved: SavedPortInfo;
			title: Str255;
			base: Point;
	begin
		CheckPopupTitle := false;
		if popup_title_menu <> nil then begin
			EnterPort(window, MFT_System0, saved);
			GlobalToLocal(where);
			GetWTitle(window, title);
			center := (window^.portRect.right + window^.portRect.left) div 2;
			width := StringWidth(title);
			base.h := center - width div 2 - 14;
			base.v := -17;
			if (where.v < 0) & (base.h <= where.h) & (where.h <= center + width div 2 + 5) then begin
				CheckPopupTitle := true;
				InsertMenu(popup_title_menu, -1);
				LocalToGlobal(base);
				CheckItem(popup_title_menu, 1, true);
				result := PopUpMenuSelect(popup_title_menu, base.v, base.h, 1);
				CheckItem(popup_title_menu, 1, false);
				DeleteMenu(popup_title_menu^^.menuID);
				if (HiWord(result) <> 0) and (LoWord(result) <> 1) then begin
					DoPopupTitle(LoWord(result));
{DrawPopUp(dialog, item);}
				end;
			end;
			ExitPort(saved);
		end;
	end;

	function WObject.DoMainClick (const er: EventRecord; wp: WindowPtr; code: integer): Boolean;
		var
			b: Boolean;
			mResult: longint;
			needsselect: Boolean;
	begin
		b := false;
		needsselect := (wp <> nil) & (wp <> FrontWindow);
		if needsselect & not (code in [inDrag, inContent]) then begin
			SelectWindow(wp);
		end;
		case code of
			inMenuBar:  begin
				SetMenus;
				mResult := MenuSelect(er.where);
				if mResult <> 0 then begin
					DoFMenu(HiWord(mResult), LoWord(mResult));
				end;
				if not quitNow then begin
					HiliteMenu(0);
				end;
			end;
			inDrag:  begin
				if needsselect | not last_event_had_command | not CheckPopupTitle(er.where) then begin
					if needsselect and not last_event_had_command then begin
						SelectWindow(wp);
					end;
					DoDrag(er.where);
				end;
			end;
			inGrow: 
				DoGrow(er.where);
			inZoomIn, inZoomOut: 
				DoZoom(er.where, code);
			inGoAway: 
				DoGoAway(er.where);
			inContent:  begin
				if needsselect then begin
					SelectWindow(wp);
				end;
				DoContent(er);
			end;
			inSysWindow: 
				SystemClick(er, window);
			otherwise begin
				b := true;
			end;
		end;
		DoMainClick := b;
	end;

	function WObject.HandleSimpleEvents (var er: EventRecord): Boolean;
		var
			b: Boolean;
			ch: char;
			mResult: longint;
			code: integer;
			wp: WindowPtr;
	begin
		b := false;
		case er.what of
			mouseDown:  begin
				code := FindWindow(er.where, wp);
				if wp = nil then begin
					wp := FrontWindow;
				end;
				b := GetWObject(wp).DoMainClick(er, wp, code);
			end;

			keyDown:  begin
				ch := EventChar( er );
				mResult := 0;
				if last_event_had_command then begin
					SetMenus;
					mResult := DoMenuKey(er, ch);
				end;
				if mResult <> 0 then begin
					DoFMenu(HiWord(mResult), LoWord(mResult));
				end else begin
					DoSpecialKey(er, ch);
				end;
			end;

			autoKey: 
				DoAutoKey(er, EventChar( er ) );

			updateEvt: 
				GetWObject(WindowPtr(er.message)).DoUpdate;

			activateEvt: 
				GetWObject(WindowPtr(er.message)).DoActivateDeactivate( EventHasActivate( er ) );

			kOSEvent: 
				if EventIsSuspendResume( er ) then begin
					DoSuspendResume( EventHasResume( er ) );
				end else if EventIsMouseMoved( er ) then begin
					DoMouseMoved(er.where);
				end else begin
					b := true;
				end;

			kHighLevelEvent: 
				DoHighLevel(er);

			diskEvt: 
				DoDiskEvent(er.message);

			otherwise begin
				b := true;
			end;
		end;
		HandleSimpleEvents := b;
	end;

	function WObject.HandleEvents (var er: EventRecord): Boolean;
		var
			b: Boolean;
			dlg: DialogPtr;
			item: integer;
			dlgsel:Boolean;
	begin
		last_event := er;
		last_event_time := er.when;
		last_event_had_option := EventHasOptionKey( er );
		last_event_had_command := EventHasCommandKey( er );
		last_event_had_shift := EventHasShiftKey( er );
		last_event_had_control := EventHasControlKey( er );
		DoIdle;
		b := true;
		if not is_default_object & (window <> nil) & not member(self,DObject) then begin
			if not EmptyRgn( WindowPeek(window)^.updateRgn ) then begin
				DoUpdate;
			end;
		end;
		if DoIsDialogEventVar(er) then begin
			dlgsel:=DoDialogSelectVar(er, dlg, item);
			if dlgsel then begin
				GetDObject(dlg).DoItemWhere(er, item);
				if er.what in [keyDown, autoKey] then begin
					TextChanged;
				end;
				b := false;
			end;
		end;
		if b then begin
			b := HandleSimpleEvents(er);
		end;
		HandleEvents := b;
	end;

	procedure WObject.MainLoopDeviceLoop(addr: Ptr; depth: integer; deviceFlags: integer; targetDevice: GDHandle; userData: univ MainLoopDeviceLoopRecordPtr);
	begin
{$unused(addr,depth,deviceFlags,targetDevice,userData)}
		Assert( false );
	end;
	
	procedure MainLoopDeviceLoop( depth: integer; deviceFlags: integer; targetDevice: GDHandle; param: longint );
		var
			userData: MainLoopDeviceLoopRecordPtr;
	begin
		userData := MainLoopDeviceLoopRecordPtr(param);
		Assert( userData <> nil );
		userData^.obj.MainLoopDeviceLoop( userData^.addr, depth, deviceFlags, targetDevice, userData );
	end;	
	
	procedure WObject.SafeMainDeviceLoop( addr: Ptr; drawingRgn: RgnHandle; userData: univ MainLoopDeviceLoopRecordPtr; flags: DeviceLoopFlags );
	begin
		userData^.obj := self;
		userData^.addr := addr;
		SafeDeviceLoop( drawingRgn, gMainLoopDeviceLoopProc, userData, flags );
	end;

	procedure WObject.SafeMainDeviceLoopRect( addr: Ptr; drawingRect: Rect; userData: univ MainLoopDeviceLoopRecordPtr; flags: DeviceLoopFlags );
		var
			drawingRgn: RgnHandle;
	begin
		drawingRgn := MNewRgn;
		RectRgn( drawingRgn, drawingRect );
		SafeMainDeviceLoop( addr, drawingRgn, userData, flags );
		MDisposeRgn( drawingRgn );
	end;
	
	procedure WObject.LDEF (message: integer; select: Boolean; const lineframe: Rect; c: Cell; dataOffset, dataLen: integer);
	begin
{$unused(message, select, lineframe, c, dataOffset, dataLen)}
		Assert( false );
	end;

	function WObject.CDEF (variation: integer; control: ControlHandle; message: integer; param: longint; depth: integer; deviceFlags: integer; targetDevice: GDHandle): longint;
	begin
{$unused(variation, control, message, param, depth, deviceFlags, targetDevice)}
		Assert( false );
		CDEF := 0;
	end;

	procedure DObject.CreateBehind (id: integer; behind: WindowPtr);
		var
			wp: myDialogPtr;
			junk: OSErr;
	begin
		disable_edit_menu := false;
		junk := MNewPtr( wp, SizeOf(myDialogRecord) );
		wp^.magic := OOMagic;
		window := GetNewDialog(id, Ptr(wp), behind);
		Assert( window <> nil );
		SetPort( window );
		Assert( WindowPtr(wp) = window );
		MNoteNewHandle( DialogPeek(window)^.items ); // Our responsibility to destroy it
		ok_item := 0;
		cancel_item := 0;
		outline_item := 0;
		text_return := false;
		support_edittext_draging_send := true;
		support_edittext_draging_receive := true;
		JointCreate(id);
	end;

	procedure DObject.Create (id: integer);
	begin
		CreateBehind(id, window_at_front);
	end;

	procedure DObject.Destroy;
	begin
		if (window <> nil) & (GetWType(window) <> WT_NotMine) then begin
			CloseDialog(window); // may call CDEF/LDEF disposes
			myDialogPtr(window)^.magic := BadOOMagic;
			MDisposeHandle( DialogPeek(window)^.items );
			JointDestroy;
		end;
	end;

	procedure DObject.DrawOutline( foreground: Boolean );
	begin
		OutlineDefault1ForeBackground( window, outline_item, foreground );
	end;

	procedure DObject.SetOOOutline (def_item, user_item: integer);
	begin
		ok_item := def_item;
		outline_item := user_item;
		SetUpDefaultOutline(window,ok_item, outline_item, false);
		HandleUserItem( outline_item );
	end;

	procedure DObject.DrawUserItem( item: integer );
	begin
{$unused(item)}
		if (outline_item > 0) & (item = outline_item) then begin
			DrawOutline( InForeground );
		end else begin
			Assert( false );
		end;
	end;

	procedure DrawUserItem( window: DialogPtr; item: integer );
	begin
		SetPort( window );
		GetDObject( window ).DrawUserItem( item );
	end;

	procedure DObject.HandleUserItem( item: integer );
	begin
		SetUserItemProc( window, item, gDrawUserItemProc );
	end;

	procedure DObject.HandleAllUserItems;
		var
			item: integer;
	begin
		for item := 1 to CountDItems( window ) do begin
			if band(GetDItemKindF( window, item ),GoodBNOT(itemDisable)) = userItem then begin
				HandleUserItem( item );
			end;
		end;
	end;

	procedure DObject.DoActivateDeactivate (activate: Boolean);
	begin
		inherited DoActivateDeactivate(activate);
		if outline_item > 0 then begin
			DrawOutline( activate );
		end;
	end;

	procedure DObject.DoTab( const er:EventRecord; backwards: Boolean );
	begin
{$unused(er)}
		if not is_default_object then begin
			ManualTab( window, backwards );
		end;
	end;
	
	procedure DObject.DoOK (const er: EventRecord; ch: char);
	begin
		if ok_item = 0 then begin
			DoKey(er, ch);
		end else begin
			if GetDControlEnable(window, ok_item) then begin
				FlashDItem(window, ok_item);
				DoItem(ok_item);
			end;
		end;
	end;

	procedure DObject.DoCancel (const er: EventRecord; ch: char);
	begin
		if cancel_item = 0 then begin
			DoKey(er, ch);
		end else begin
			FlashDItem(window, cancel_item);
			DoItem(cancel_item);
		end;
	end;

	procedure DObject.DoItem (item: integer);
	begin
{$unused(item)}
	end;

	procedure DObject.DoItemWhere (const er: EventRecord; item: integer);
	begin
{$unused(er)}
		DoItem(item);
	end;

	function DObject.HandleEvents (var er: EventRecord): Boolean;
		var
			b: Boolean;
			ch: char;
	begin
		b := true;
		if EventIsKeyDown( er ) then begin
			b := false;
			ch := EventChar( er );
			if ((ch <> cr) | not text_return) & EventHasOK( er ) then begin
				DoOK(er, ch);
			end else if EventHasCancel( er ) then begin
				DoCancel(er, ch);
			end else if (ch = tab) then begin
				DoTab( er, EventHasShiftKey( er ) );
				b := false;
			end else begin
				b := true;
			end;
		end;
		if b then begin
			b := inherited HandleEvents(er);
		end;
		HandleEvents := b;
	end;

	procedure DObject.SetEditMenuItem (item: integer);
	begin
		if is_default_object | disable_edit_menu | (SelectedTextItem(window) <= 0) then begin
			SetIDItemEnable(M_Edit, item, false);
		end else begin
			TESetEditMenuItem(DialogPeek(window)^.textH, false, 250, item);
		end;
	end;
(*
	function DObject.EditMenuEnabled: Boolean;
	begin
		if is_default_object | disable_edit_menu | (SelectedTextItem(window) <= 0) then begin
			EditMenuEnabled := false;
		end else begin
			EditMenuEnabled := TEEditMenuEnabled(DialogPeek(window)^.textH, false, 250);
		end;
	end;
*)
	procedure DObject.DoDialogCut;
	begin
		MyDialogCut( window );
	end;

	procedure DObject.DoDialogCopy;
	begin
		MyDialogCopy( window );
	end;

	procedure DObject.DoDialogPaste;
	begin
		MyDialogPaste( window );
	end;

	procedure DObject.DoDialogDelete;
	begin
		MyDialogDelete( window );
	end;

	procedure DObject.DoEditMenu (item: integer);
		var
			loe: longint;
			oe: OSErr;
	begin
		case item of
			EMundo: 
				;
			EMcut:  begin
				DoDialogCut;
				loe := ZeroScrap;
				oe := TEToScrap;
				TextChanged;
			end;
			EMcopy:  begin
				DoDialogCopy;
				loe := ZeroScrap;
				oe := TEToScrap;
			end;
			EMpaste:  begin
				oe := TEFromScrap;
				DoDialogPaste;
				TextChanged;
			end;
			EMclear:  begin
				DoDialogDelete;
				TextChanged;
			end;
			EMselectall:  begin
				if (SelectedTextItem(window) > 0) then begin
					SelectDialogItemText(window, SelectedTextItem(window), 0, maxInt);
				end;
			end;
			otherwise begin
				{ do nothing }
			end;
		end;
	end;

	function DObject.GetAESelection (var reply: AppleEvent): OSErr;
		var
			err: OSErr;
	begin
		if not is_default_object & (SelectedTextItem(window) > 0) then begin
			err := PutTESelectionToAERecord(reply, keyDirectObject, DialogPeek(window)^.textH);
		end else begin
			err := errAENoUserSelection;
		end;
		GetAESelection := err;
	end;

	function DObject.DoIsDialogEventVar (var er: EventRecord): Boolean;
		var
			wp: WindowPtr;
			doit: Boolean;
			curitem, clickitem: integer;
			localwhere: Point;
			wasdragged, wastrashed: Boolean;
	begin
		doit := true;
		if EventIsKeyDown( er ) and EventHasCommandKey( er ) then begin
			doit := false; { Stop system 7 from doing the edit menu as well }
		end;
		if doit & support_edittext_draging_send & (er.what=mouseDown) & (FindWindow(er.where, wp) = inContent) & (wp = window) then begin
			curitem := SelectedTextItem( window );
			if curitem > 0 then begin
				SetPort( window );
				localwhere := er.where;
				GlobalToLocal( localwhere );
				clickitem := FindDialogItem( window, localwhere ) + 1; { GlobalToLocal? }
				if (clickitem = curitem) & PtInTEHiliteRgn( localwhere, DialogPeek(window)^.textH ) then begin
					if (DragText( er, localwhere, DialogPeek(window)^.textH, false, wasdragged, wastrashed ) = noErr) & wasdragged then begin
						if wastrashed then begin
							DoDialogDelete;
						end;
						doit := false;
					end;
				end;
			end;
		end;
		if doit then begin
			doit := inherited DoIsDialogEventVar(er);
		end;
		DoIsDialogEventVar := doit;
	end;

	var
		drop_on_field_index: integer;
		drop_on_field_location: integer;

	function DObject.MyTrackingEnterWindow( dragref: DragReference ): Boolean;
	begin
		if support_edittext_draging_receive then begin
			MyTrackingEnterWindow := IsDragTypeAvailable( dragref, 'TEXT' );
		end else begin
			MyTrackingEnterWindow := false;
		end;
	end;

	procedure DObject.MyTrackingLeaveWindow( dragref: DragReference );
	begin
{$unused(dragref)}
	end;

	procedure DObject.MyTrackingInWindow( dragref: DragReference; localwhere: Point; var new_drag_hilited: Boolean; new_drag_hilite_rgn, new_drag_invert_rgn: RgnHandle );
		var
			item, start, fin: integer;
			cur_modifiers, mousedown_modifiers, mouseup_modifiers: integer;
			attributes: DragAttributes;
			docopy: Boolean;
			junk: OSStatus;
	begin
{$unused(dragref)}
		DialogGetTextDropInformation( window, localwhere, drop_on_field_index, drop_on_field_location, new_drag_hilite_rgn, new_drag_invert_rgn );
		new_drag_hilited := drop_on_field_index > 0;
		if new_drag_hilited then begin
			GetDialogTextSelection( window, item, start, fin );
			if drop_on_field_index = item then begin
				junk := GetDragAttributes( dragref, attributes );
				junk := GetDragModifiers( dragref, cur_modifiers, mousedown_modifiers, mouseup_modifiers );
				docopy := (band(attributes, kDragInsideSenderWindow) = 0) | (band(bor(mousedown_modifiers, cur_modifiers), optionKey) <> 0);
				if docopy then begin
					if (start < drop_on_field_location) & (drop_on_field_location < fin) then begin
						new_drag_hilited := false;
					end;
				end else begin
					if (start <= drop_on_field_location) & (drop_on_field_location <= fin) then begin
						new_drag_hilited := false;
					end;
				end;
			end;
		end;
	end;

	procedure DObject.InsertTextAndSelect( field: integer; offset: integer; data: Str255 );
		var
			field_contents: Str255;
	begin
		GetItemText( window, field, field_contents );
		if length( field_contents ) + length( data ) > 255 then begin
			data := TPcopy( data, 1, 255-length( field_contents ) );
		end;
		MidAssignP( field_contents, offset + 1, 0, data );
		SetItemText( window, field, field_contents );
		SelectDialogItemText( window, field, offset, offset + length(data) );
	end;

	function DObject.ReceiveHandler(dragref: DragReference): OSErr;
		var
			err, junk: OSErr;
			drag_contents: Str255;
			docopy: Boolean;
			attributes: DragAttributes;
			in_sender_window: Boolean;
			cur_modifiers, mousedown_modifiers, mouseup_modifiers: integer;
			dragdata: Handle;
			selStart, selEnd: integer;
	begin
		TrackingRemoveHiliting( dragref );
		if drop_on_field_index > 0 then begin
			junk := GetDragAttributes(dragref, attributes);
			junk := GetDragModifiers(dragref, cur_modifiers, mousedown_modifiers, mouseup_modifiers );

			in_sender_window := (band(attributes, kDragInsideSenderWindow) <> 0);
			docopy := not in_sender_window | (band(bor(mousedown_modifiers, mouseup_modifiers), optionKey) <> 0);

{			drop_on_field_finish := drop_on_field_location;}

			junk := MNewHandle( dragdata, 0 );
			err := GetTextDragData( dragref, dragdata );
			if err = noErr then begin
				HandleToString( dragdata, drag_contents );
				if docopy then begin
					InsertTextAndSelect( drop_on_field_index, drop_on_field_location, drag_contents );
				end else if SelectedTextItem( window ) <> drop_on_field_index then begin
					DoDialogDelete;
					InsertTextAndSelect( drop_on_field_index, drop_on_field_location, drag_contents );
				end else begin
					GetDialogTextSelection( window, drop_on_field_index, selStart, selEnd );
					DoDialogDelete;
					if (selStart <= drop_on_field_location) & (drop_on_field_location <= selEnd) then begin
						{ should never happen except on edge of boundary }
						drop_on_field_location := selStart;
					end else if drop_on_field_location > selEnd then begin
						drop_on_field_location := drop_on_field_location - (selEnd-selStart);
					end;
					InsertTextAndSelect( drop_on_field_index, drop_on_field_location, drag_contents );
				end;
			end;
			MDisposeHandle( dragdata );
		end;
		ReceiveHandler := err;
	end;

	procedure DObject.CalculateRegion (var rgn: RgnHandle);
		var
			item:integer;
			pt:Point;
	begin
		rgn := nil;
		item:=0;
		if (window<>nil) then begin
			SetPort(window);
			GetMouse(pt);
			item:=FindDialogItem(window,pt)+1;
			if item>0 then begin
				if GetDItemKindF(window,item)<>editText then begin
					item:=0;
				end;
			end;
		end;
		if item>0 then begin
			CursorSetIBeam;
		end else begin
			CursorSetArrow;
		end;
	end;

	procedure CallLDEF (message: integer; select: Boolean; var lineframe: Rect; c: Cell; dataOffset, dataLen: integer; lh: ListHandle);
		var
			obj: WObject; { BUG IN MWP }
	begin
		obj := GetWObject(lh^^.port);
		obj.LDEF(message, select, lineframe, c, dataOffset, dataLen);
	end;
	
	type
		CDEFDeviceLoopParams = record
			obj: WObject;
			variation: integer;
			control: ControlHandle;
			msg: integer;
			param: longInt;
		end;
		CDEFDeviceLoopParamsPtr = ^CDEFDeviceLoopParams;

	procedure CDEFDeviceLoop( depth: integer; deviceFlags: integer; targetDevice: GDHandle; param: longint );
		var
			userData: CDEFDeviceLoopParamsPtr;
			junk: longint;
	begin
		userData := CDEFDeviceLoopParamsPtr(param);
		Assert( userData <> nil );
		junk := userData^.obj.CDEF( userData^.variation, userData^.control, userData^.msg, userData^.param, depth, deviceFlags, targetDevice );
		Assert( junk = 0 );
	end;	
(*
	procedure DebugCDEFMessage(variation: integer; control: ControlHandle; msg: integer; param: longInt);
		var
			spec: FSSpec;
			rn: integer;
			err: OSErr;
			s: Str255;
			len: longint;
	begin
		err := FSMakeFSSpec( -1, 2, 'DebugCDEFMessage', spec );
		err := FSpCreate( spec, 'R*ch', 'TEXT', 0 );
		err := FSpOpenDF( spec, fsRdWrPerm, rn );
		if err = noErr then begin
			err := SetFPos( rn, fsFromLEOF, 0 );
			if err = noErr then begin
				s := NumToStr(variation) + tab + NumToStr(ord4(control)) + tab + NumToStr(msg) + tab + NumToStr(param) + cr;
				len := length(s);
				err := FSWrite( rn, len, @s[1] );
			end;
			err := FSClose( rn );
		end;
	end;
*)
	function CallCDEF (variation: integer; control: ControlHandle; msg: integer; param: longInt): longInt;
		var
			result: longint;
			obj: WObject; { BUG IN MWP }
			params: CDEFDeviceLoopParams;
	begin
		obj := GetWObject(control^^.contrlOwner);
		if msg = drawCntl then begin
			params.obj := obj;
			params.variation := variation;
			params.control := control;
			params.msg := msg;
			params.param := param;
			SafeDeviceLoopRect( control^^.contrlRect, gCDEFDeviceLoopProc, @params, 0 );
			result := 0;
		end else if msg = dispCntl then begin
			MDisposeHandle( control^^.contrlData );
			result := 0;
		end else begin
			if msg = initCntl then begin
				Assert( control^^.contrlData = nil );
			end;
			result := obj.CDEF(variation, control, msg, param, 0, 0, nil);
		end;
		CallCDEF := result;
	end;

	function HasDragLib:Boolean;
	begin
{$IFC GENERATINGPOWERPC}
		HasDragLib := longint(@InstallTrackingHandler) <> kUnresolvedCFragSymbolAddress;
{$ELSEC}
		HasDragLib := true;
{$ENDC}
	end;

	procedure IdleMainLoop;
		var
			fw,next: WindowPtr;
			obj: WObject;
	begin
		fw:=FrontWindowList;
		while fw<>nil do begin
			next := NextWindowList ( fw );
			obj := GetWObject(fw);
			if has_Appearance then begin
				IdleControls( obj.window );
			end;
			if obj.timetoclose then begin
				obj.DoClose;
			end else begin
				obj.DoIdleAlways;
			end;
			fw:=next;
		end;
	end;
	
	procedure AppendToHandleMenuEnabled( menu: MenuNumber );
		var
			junk: OSErr;
	begin
		junk := MAppendToHandle( gHandleMenuEnabled, @menu, SizeOf(MenuNumber) );
		Assert( junk = noErr );
	end;

	function InitMainLoop(var msg: integer): OSStatus;
		var
			i: integer;
			dummy: Boolean;
			dummy_er: EventRecord;
			junk: OSErr;
			HandleCloseProc:UniversalProcPtr;
			gv: longint;
	begin
{$unused(msg)}
		AssertDidStartup( startup_check );
		has_DragManager := HasDragLib & (Gestalt(gestaltDragMgrAttr, gv) = noErr) & (BTST(gv, gestaltDragMgrPresent));
		gMyDragSendProc := NewDragSendDataProc(MyDragSend);
		gDrawUserItemProc := NewUserItemProc(DrawUserItem);
		gMainLoopDeviceLoopProc:=NewDeviceLoopDrawingProc(MainLoopDeviceLoop);
		gCallLDEFProc := NewListDefProc(CallLDEF);
		gCallCDEFProc := NewControlDefProc(CallCDEF);
		gCDEFDeviceLoopProc:=NewDeviceLoopDrawingProc(CDEFDeviceLoop);
		junk := MNewHandle( gHandleMenuEnabled, 0 );
		Assert( junk = noErr );
		AppendToHandleMenuEnabled( M_Edit );
		for i := 1 to 5 do begin
			dummy := EventAvail(everyEvent, dummy_er);
		end;
		if has_DragManager then begin
			junk := InstallTrackingHandler(NewDragTrackingHandlerProc(MyTrackingHandler), nil, nil);
			junk := InstallReceiveHandler(NewDragReceiveHandlerProc(MyReceiveHandler), nil, nil);
		end;
		default_object.window := nil;
		default_object.window_id := bad_window_id;
		default_object.JointCreate(0);		
		default_object.is_default_object := true;
		default_object.window_type := WT_NotMine;
		last_window_id := 1;
//		edit_menu_always_enabled := false;
		if has_AppleEvents then begin
			HandleCloseProc:=NewAEEventHandlerProc(HandleClose);
			junk := AEInstallEventHandler(kAECoreSuite, kAEClose,HandleCloseProc , 0, false);
			junk := AEInstallEventHandler(kAECoreSuite, kAECloseAll,HandleCloseProc , 1, false);
		end;
		InitMainLoop := noErr;
	end;

	procedure FinishMainLoop;
	begin
		MDisposeObject( default_object );
		MDisposeHandle( gHandleMenuEnabled );
	end;

	procedure ConfigureMainLoop (dobj: DObject);
	begin
		DidStartup( startup_check );
		StartupMainLoop;
		default_object := dobj;
	end;

	procedure StartupMainLoop;
	begin
		StartupCleverAlerts;
		StartupCursors;
		StartupDialogs;
		StartupFMenus;
		SetStartup(InitMainLoop, IdleMainLoop, 15, FinishMainLoop);
	end;

end.
	procedure WObject.SetAllControlEnables( on: Boolean );
		var
			control: ControlHandle;
	begin
		control := ControlHandle(WindowPeek(window)^.controlList);
		while control <> nil do begin
			SetControlEnable( control, on );
			control := control^^.nextControl;
		end;
	end;
	
		edit_menu_always_enabled: Boolean;
