unit MyRegions;

interface

	uses
		MacOS;
		
	procedure LocalToGlobalRegion( rgn: RgnHandle );
	procedure GlobalToLocalRegion( rgn: RgnHandle );
	procedure OutlineRegion( rgn: RgnHandle );
	procedure MakeRegionEmpty (rgn: RgnHandle);
	procedure UnionRgnRect( rgn: RgnHandle; const r: Rect );
	procedure SubRgnRect( rgn: RgnHandle; const r: Rect );

implementation

	uses
		MyMemory;
		
	procedure MakeRegionEmpty (rgn: RgnHandle);
		var
			r: Rect;
	begin
		SetRect(r, 0, 0, 0, 0);
		RectRgn(rgn, r);
	end;

	procedure LocalToGlobalRegion( rgn: RgnHandle );
		var
			where: Point;
	begin
		where := Point(0);
		LocalToGlobal( where );
		OffsetRgn( rgn, where.h, where.v );
	end;

	procedure GlobalToLocalRegion( rgn: RgnHandle );
		var
			where: Point;
	begin
		where := Point(0);
		GlobalToLocal( where );
		OffsetRgn( rgn, where.h, where.v );
	end;

	procedure OutlineRegion( rgn: RgnHandle );
		var
			temprgn: RgnHandle;
	begin
		temprgn := MNewRgn;
		CopyRgn( rgn, temprgn );
		InsetRgn( temprgn, 1, 1 );
		DiffRgn( rgn, temprgn, rgn );
		MDisposeRgn( temprgn );
	end;

	procedure UnionRgnRect( rgn: RgnHandle; const r: Rect );
		var
			tmp: RgnHandle;
	begin
		tmp := MNewRgn;
		RectRgn( tmp, r );
		UnionRgn( rgn, tmp, rgn );
		MDisposeRgn( tmp );
	end;

	procedure SubRgnRect( rgn: RgnHandle; const r: Rect );
		var
			tmp: RgnHandle;
	begin
		tmp := MNewRgn;
		RectRgn( tmp, r );
		DiffRgn( rgn, tmp, rgn );
		MDisposeRgn( tmp );
	end;

end.
