unit MySizeResource;

interface

{$PUSH}
{$ALIGN MAC68K}

	type
		sizeRsrc = packed record
				obsolete1: Boolean;
				accept_suspend_events: Boolean;
				obsolete2: Boolean;
				can_background: Boolean;
				does_activate_on_fg_switch: Boolean;
				only_background: Boolean;
				get_front_clicks: Boolean;
				accept_app_died_events: Boolean;
				bit_32_compatibile: Boolean;
				high_level_event_aware: Boolean;
				local_remote_hl_events: Boolean;
				stationary_aware: Boolean;
				use_textedit_services: Boolean;
				reserved1: Boolean;
				reserved2: Boolean;
				reserved3: Boolean;
				size: longint;
				min_size: longint;
			end;

{$ALIGN RESET}
{$POP}

	procedure GetSizeResource (var size: sizeRsrc);

implementation

	uses
		MyMemory, MyResources, MySystemGlobals;
	
	function GetValidSizeResource( id: integer ): Handle;
		var
			data: Handle;
	begin
		if (MGetResource( app_resfile, 'SIZE', id, data ) <> noErr) | (MGetHandleSize(data) <> SizeOf(sizeRsrc)) then begin
			MDisposeHandle( data );
		end;
		GetValidSizeResource := data;
	end;

	procedure GetSizeResource (var size: sizeRsrc);
		var
			hhhh: Handle;
	begin
		hhhh := GetValidSizeResource( 0 );
		if hhhh <> nil then begin
			hhhh := GetValidSizeResource( -1 );
		end;
		if hhhh = nil then begin
			MZero( @size, SizeOf(size) );
			size.size := longint(384) * 1024;
			size.min_size := longint(384) * 1024;
		end else begin
			BlockMoveData(hhhh^, @size, SizeOf(sizeRsrc));
			MDisposeHandle( hhhh );
		end;
	end;

end.