unit MySortCollections;

interface

	uses
		MyCollections;
	
	type
		GetSortStringProc = procedure( collection: MyCollection; index: integer; ascend: Boolean; var s: Str255; refnum: longint );

	procedure SortCollection( list: ListHandle; collection: MyCollection; GetSortString: GetSortStringProc; ascend: Boolean; refnum: longint );
// list may be nil

implementation

	uses
		MyListManager, MyMemory, MyLowLevel, MyStrings;
		
	procedure SortCollection( list: ListHandle; collection: MyCollection; GetSortString: GetSortStringProc; ascend: Boolean; refnum: longint );
		var
			i, j: integer;
			map: PermuteArrayPtr;
			count: integer;
			strhandle: Handle;
			strsize: integer;
			err: OSErr;
			sp, spi, spj: StringPtr;
			dummys: Str255;
			h, v: integer;
			selections: MyCollection;
	begin
		if list <> nil then begin
			LReadSelections( list, selections );
		end;
		count := collection.Count;
		if count > 1 then begin
			if MNewPtr( map, longint(count) * 4 ) = noErr then begin
				strsize := 0;
				for i := 1 to count do begin
					GetSortString( collection, i, ascend, dummys, refnum );
					if length(dummys) > strsize then begin
						strsize := length(dummys);
					end;
				end;
				strsize := strsize + 1;
				if odd(strsize) then begin
					strsize := strsize + 1;
				end;
				err := MNewTempHandle( strhandle, longint(count) * strsize );
				if err <> noErr then begin
					err := MNewHandle( strhandle, longint(count) * strsize );
				end;
				if err = noErr then begin
					MHLock(strhandle);
					sp := StringPtr(strhandle^);
					for i := 1 to count do begin
						GetSortString( collection, i, ascend, sp^, refnum );
						OffsetPtr(sp, strsize);
					end;

					for i := 1 to count do begin
						map^[i] := i;
					end;
					h := 1;
					while h <= count do begin
						h := 3 * h + 1;
					end;
					repeat
						h := h div 3;
						for i := h + 1 to count do begin
							v := map^[i];
							spi := StringPtr(AddPtrLong(strhandle^, longint(strsize) * (v - 1)));
							j := i;
							while (j > h) do begin
								spj := StringPtr(AddPtrLong(strhandle^, longint(strsize) * (map^[j - h] - 1)));
								if (ascend & (NaturalOrderCompareString( spj^, spi^) <= 0)) | (not ascend & (NaturalOrderCompareString( spj^, spi^) >= 0)) then begin
									leave;
								end;
								map^[j] := map^[j - h];
								j := j - h;
							end;
							map^[j] := v;
						end;
					until h = 1;

					MDisposeHandle(strhandle);
					collection.Permute(map);
					if list <> nil then begin
						selections.Permute(map);
						LWriteSelections( list, selections );
					end;
					MDisposePtr( map );
				end;
			end;
		end;
		if list <> nil then begin
			selections.Destroy;
		end;
	end;

end.