unit MyStrings;

interface

	uses
		MyTypes;

	procedure LeftP (var s: Str255; len: integer);
	function LeftF (var s: Str255; len: integer): Str255;
	procedure LeftAssignP (var s: Str255; len: integer; var rhs: Str255);
	function LeftAssign (var s: Str255; len: integer; var rhs: Str255): Str255;
	procedure RightP (var s: Str255; len: integer);
	function RightF (var s: Str255; len: integer): Str255;
	procedure RightAssignP (var s: Str255; len: integer; var rhs: Str255);
	function RightAssign (var s: Str255; len: integer; var rhs: Str255): Str255;
	procedure MidP (var s: Str255; p, len: integer);
	function Mid (var s: Str255; p, len: integer): Str255;
	procedure MidAssignP (var s: Str255; p, len: integer; const rhs: Str255);
	function MidAssign (const s: Str255; p, len: integer; const rhs: Str255): Str255;
	procedure HandleToString (hhhh: univ Handle; var s: Str255);
	function HandleToStr (hhhh: univ Handle): Str255;
	procedure StringToHandle (const s: Str255; hhhh: univ Handle);
	function Trim (s: string): string;
	function LowerCase( ch: char ): char;
	function UpperCaseChar (ch: char): char;
	function IsDigit(ch:char):Boolean;
	function IsHexDigit(ch:char):Boolean;
	function IsLower(ch:char):Boolean;
	function IsUpper(ch:char):Boolean;
	function IsAlpha(ch:char):Boolean;

	procedure UpperCaseString (var s: string);
	function UpperCaseStr (s: string): string;
	procedure LowerCaseString (var s: string);
	function LowerCaseStr (s: string): string;

	function NoCaseEquals( s1, s2: string ): Boolean;
	function NoCasePos( s1, s2: string ): integer;

	procedure SPrintS5 (var dst: Str255; const src, s1, s2, s3, s4, s5: Str255);
	procedure SPrintS3 (var dst: Str255; const src, s1, s2, s3: Str255);

	function PosRight (sub: char; const s: Str255): integer;
	function PosRightStr (const sub, s: Str255): integer;
	function Contains( sub: char; const s: Str255 ): Boolean;
	function ContainsStr( const sub, s: Str255 ): Boolean;
	procedure SplitBy (s: Str255; sub: char; var left, right: Str255);
	procedure SplitRightBy (s: Str255; sub: char; var left, right: Str255);
	procedure SplitByStr (s: Str255; const sub: Str255; var left, right: Str255);
	procedure SplitRightByStr (s: Str255; const sub: Str255; var left, right: Str255);
	function SplitAt (s: Str255; sub: char; var s1, s2: Str255): Boolean;
	function SplitRightAt(s: Str255; sub: char; var s1, s2: Str255): Boolean;
	function SplitAtStr (s: Str255; const sub: Str255; var s1, s2: Str255): Boolean;
	function SplitRightAtStr (s: Str255; const sub: Str255; var s1, s2: Str255): Boolean;
{	function Pos (sub, str: string): integer;}
	function TPcopy (source: string; start, count: integer): string;

	function Match (pattern, name: Str255): Boolean;
	procedure LimitStringLength (var s: string; len: integer; delimiter: char);
	function StringToOSType (const s: Str255): OSType;
	function OSTypeToString (t: OSType): Str255;
	function FindCharacter(p:Ptr; len:longint; ch:Char; var pos:longint):Boolean;

	function NaturalOrderCompareString( const s1, s2: string ): integer;
		// Changed to case insensitive

	function IsExtension (const name, ext: Str255): Boolean;
	function IsPrefix (const name, prefix: Str255): Boolean;
	procedure DeleteExtension( var name: Str255; const ext: Str255 );
	procedure DeletePrefix( var name: Str255; const ext: Str255 );
	
	function IsAllInSet( const s: string; cs: CharSet ): Boolean;

implementation

	uses
		MyMathUtils, MyLowLevel, MyMemory;

	function FindCharacter(p:Ptr; len:longint; ch:Char; var pos:longint):Boolean;
	begin
		pos:=0;
		while (pos<len) & (AddPtrLong(p,pos)^<>ord(ch)) do begin
			pos:=pos+1;
		end;
		FindCharacter:= pos<len;
	end;

	procedure LeftP (var s: Str255; len: integer);
	begin
		s := TPcopy(s, 1, len);
	end;

	function LeftF (var s: Str255; len: integer): Str255;
	begin
		LeftF := TPcopy(s, 1, len);
	end;

	procedure LeftAssignP (var s: Str255; len: integer; var rhs: Str255);
	begin
		s := concat(rhs, TPcopy(s, len + 1, 255));
	end;

	function LeftAssign (var s: Str255; len: integer; var rhs: Str255): Str255;
	begin
		LeftAssign := concat(rhs, TPcopy(s, len + 1, 255));
	end;

	procedure RightP (var s: Str255; len: integer);
		var
			p: integer;
	begin
		p := Length(s) - len;
		if p < 1 then begin
			p := 1;
		end;
		s := TPcopy(s, p, 255);
	end;

	function RightF (var s: Str255; len: integer): Str255;
		var
			p: integer;
	begin
		p := Length(s) - len;
		if p < 1 then begin
			p := 1;
		end;
		RightF := TPcopy(s, p, 255);
	end;

	procedure RightAssignP (var s: Str255; len: integer; var rhs: Str255);
	begin
		s := concat(TPcopy(s, 1, Length(s) - len), rhs);
	end;

	function RightAssign (var s: Str255; len: integer; var rhs: Str255): Str255;
	begin
		RightAssign := concat(TPcopy(s, 1, Length(s) - len), rhs);
	end;

	procedure MidP (var s: Str255; p, len: integer);
	begin
		s := TPcopy(s, p, len);
	end;

	function Mid (var s: Str255; p, len: integer): Str255;
	begin
		Mid := TPcopy(s, p, len);
	end;

	procedure MidAssignP (var s: Str255; p, len: integer; const rhs: Str255);
	begin
		s := concat(TPcopy(s, 1, p - 1), rhs, TPcopy(s, p + len, 255));
	end;

	function MidAssign (const s: Str255; p, len: integer; const rhs: Str255): Str255;
	begin
		MidAssign := concat(TPcopy(s, 1, p - 1), rhs, TPcopy(s, p + len, 255));
	end;

{$PUSH}
{$R-}
	procedure HandleToString (hhhh: univ Handle; var s: Str255);
		var
			len: longint;
	begin
		len := Min(255, MGetHandleSize(hhhh));
		s[0] := chr(len);
		BlockMoveData(hhhh^, @s[1], len);
	end;
{$POP}

	function HandleToStr (hhhh: univ Handle): Str255;
		var
			s: Str255;
	begin
		HandleToString(hhhh, s);
		HandleToStr := s;
	end;

	procedure StringToHandle (const s: Str255; hhhh: univ Handle);
		var
			err: OSErr;
	begin
		err := MSetHandleSize(hhhh, length(s));
		Assert( err = noErr );
		if (err = noErr) & (length(s) > 0) then begin
			BlockMoveData(@s[1], hhhh^, length(s));
		end;
	end;

	function Trim (s: string): string;
	begin
		while (length(s) > 0) and (s[1] in [spc, tab, cr, lf]) do begin
			Delete(s, 1, 1);
		end;
		while (length(s) > 0) and (s[length(s)] in [spc, tab, cr, lf]) do begin
			Delete(s, length(s), 1);
		end;
		Trim := s;
	end;

	function LowerCase( ch: char ): char;
	begin
		if ('A' <= ch) & (ch <= 'Z') then begin
			ch := chr(ord(ch) + $20);
		end;
		LowerCase := ch;
	end;

	function UpperCaseChar (ch: char): char;
	begin
		if ('a' <= ch) & (ch <= 'z') then begin
			ch := chr(ord(ch) - $20);
		end;
		UpperCaseChar := ch;
	end;

	function IsDigit(ch:char):Boolean;
	begin
		IsDigit := ('0'<=ch) & (ch<='9');
	end;

	function IsHexDigit(ch:char):Boolean;
	begin
		IsHexDigit := (('0'<=ch) & (ch<='9')) | (('A'<=ch) & (ch<='F')) | (('a'<=ch) & (ch<='f'));
	end;
	
	function IsLower(ch:char):Boolean;
	begin
		IsLower := ('a'<=ch) & (ch<='z');
	end;

	function IsUpper(ch:char):Boolean;
	begin
		IsUpper := ('A'<=ch) & (ch<='Z');
	end;

	function IsAlpha(ch:char):Boolean;
	begin
		IsAlpha := (('a'<=ch) & (ch<='z')) | (('A'<=ch) & (ch<='Z'));
	end;

	function NoCaseEquals( s1, s2: string ): Boolean;
	begin
		LowerCaseString( s1 );
		LowerCaseString( s2 );
		NoCaseEquals := s1 = s2;
	end;

	function NoCasePos( s1, s2: string ): integer;
	begin
		LowerCaseString( s1 );
		LowerCaseString( s2 );
		NoCasePos := Pos( s1, s2 );
	end;

	procedure LowerCaseString (var s: string);
		var
			i: integer;
	begin
		for i := 1 to length(s) do begin
			s[i] := LowerCase(s[i]);
		end;
	end;

	function LowerCaseStr (s: string): string;
		var
			i: integer;
	begin
		for i := 1 to length(s) do begin
			s[i] := LowerCase(s[i]);
		end;
		LowerCaseStr := s;
	end;

	procedure UpperCaseString (var s: string);
		var
			i: integer;
	begin
		for i := 1 to length(s) do begin
			s[i] := UpperCaseChar(s[i]);
		end;
	end;

	function UpperCaseStr (s: string): string;
		var
			i: integer;
	begin
		for i := 1 to length(s) do begin
			s[i] := UpperCaseChar(s[i]);
		end;
		UpperCaseStr := s;
	end;

	function TPcopy (source: string; start, count: integer): string;
	begin
		if (start < 1) then begin
			count := count - (1 - start);
			start := 1;
		end;
		if start + count > length(source) then begin
			count := length(source) - start + 1;
		end;
		if count < 0 then begin
			count := 0;
		end;
		source[0] := chr(count);
		BlockMoveData(@source[start], @source[1], count);
		TPcopy := source;
	end;
{
	function Pos (sub, str: string): integer;
		var
			i, j, ret: integer;
	begin
		i := 1;
		ret := 1;
		if length(sub) > 0 then begin
			ret := 0;
			while (i <= length(str) - length(sub) + 1) do begin
				if str[i] = sub[1] then begin
					j:=2;
					while j<=length(sub) do begin
						if str[i+j-1]<>sub[j] then begin
							leave;
						end;
						j:=j+1;
					end;
					if j>length(sub) then begin
						ret:=i;
						leave;
					end;
				end;
				i := i + 1;
			end;
		end;
		Pos := ret;
	end;

}	procedure DoSub (var dst: Str255; n: integer; const s: Str255);
		var
			p: integer;
	begin
		p := Pos(concat('^', chr(n + 48)), dst);
		if p > 0 then begin
			Delete(dst, p, 2);
			Insert(s, dst, p);
		end;
	end;

	procedure SPrintS5 (var dst: Str255; const src, s1, s2, s3, s4, s5: Str255);
		var
			temp: Str255;
	begin
		temp := src;
		DoSub(temp, 5, s5);
		DoSub(temp, 4, s4);
		DoSub(temp, 3, s3);
		DoSub(temp, 2, s2);
		DoSub(temp, 1, s1);
		dst := temp;
	end;

	procedure SPrintS3 (var dst: Str255; const src, s1, s2, s3: Str255);
		var
			temp: Str255;
	begin
		temp := src;
		DoSub(temp, 3, s3);
		DoSub(temp, 2, s2);
		DoSub(temp, 1, s1);
		dst := temp;
	end;

	function PosRight (sub: char; const s: Str255): integer;
		var
			p: integer;
	begin
		p := length(s);
		while p > 0 do begin
			if s[p] = sub then begin
				leave;
			end;
			Dec(p);
		end;
		PosRight := p;
	end;

	function PosRightStr (const sub, s: Str255): integer;
		var
			p, q: integer;
	begin
		p := Pos(sub, s);
		if p > 0 then begin
			q := length(s) - length(sub) + 1;
			while q > p do begin
				if TPcopy(s, q, length(sub)) = sub then begin
					p := q;
				end else begin
					q := q - 1;
				end;
			end;
		end;
		PosRightStr := p;
	end;

	function Contains( sub: char; const s: Str255 ): Boolean;
	begin
		Contains := Pos( sub, s ) > 0;
	end;

	function ContainsStr( const sub, s: Str255 ): Boolean;
	begin
		ContainsStr := Pos( sub, s ) > 0;
	end;

	procedure SplitBy (s: Str255; sub: char; var left, right: Str255);
		var
			p: integer;
	begin
		p := Pos(sub, s);
		if p <= 0 then begin
			left := s;
			right := '';
		end else begin
			left := TPcopy(s, 1, p - 1);
			right := TPcopy(s, p + 1, 255);
		end;
	end;

	procedure SplitRightBy (s: Str255; sub: char; var left, right: Str255);
		var
			p: integer;
	begin
		p := PosRight(sub, s);
		if p <= 0 then begin
			left := '';
			right := s;
		end else begin
			left := TPcopy(s, 1, p - 1);
			right := TPcopy(s, p + 1, 255);
		end;
	end;

	procedure SplitByStr (s: Str255; const sub: Str255; var left, right: Str255);
		var
			p: integer;
	begin
		p := Pos(sub, s);
		if p <= 0 then begin
			left := s;
			right := '';
		end else begin
			left := TPcopy(s, 1, p - 1);
			right := TPcopy(s, p + 1, 255);
		end;
	end;

	procedure SplitRightByStr (s: Str255; const sub: Str255; var left, right: Str255);
		var
			p: integer;
	begin
		p := PosRightStr(sub, s);
		if p <= 0 then begin
			left := '';
			right := s;
		end else begin
			left := TPcopy(s, 1, p - 1);
			right := TPcopy(s, p + 1, 255);
		end;
	end;

	function SplitAt (s: Str255; sub: char; var s1, s2: Str255): Boolean;
		var
			p: integer;
	begin
		p := Pos(sub, s);
		if p > 0 then begin
			s1 := TPcopy(s, 1, p - 1);
			s2 := TPcopy(s, p + 1, 255);
		end;
		SplitAt := p > 0;
	end;

	function SplitRightAt(s: Str255; sub: char; var s1, s2: Str255): Boolean;
		var
			p: integer;
	begin
		p := PosRight(sub, s);
		if p > 0 then begin
			s1 := TPcopy(s, 1, p - 1);
			s2 := TPcopy(s, p + 1, 255);
		end;
		SplitRightAt := p > 0;
	end;

	function SplitAtStr (s: Str255; const sub: Str255; var s1, s2: Str255): Boolean;
		var
			p: integer;
	begin
		p := Pos(sub, s);
		if p > 0 then begin
			s1 := TPcopy(s, 1, p - 1);
			s2 := TPcopy(s, p + length(sub), 255);
		end;
		SplitAtStr := p > 0;
	end;

	function SplitRightAtStr (s: Str255; const sub: Str255; var s1, s2: Str255): Boolean;
		var
			p: integer;
	begin
		p := PosRightStr(sub, s);
		if p > 0 then begin
			s1 := TPcopy(s, 1, p - 1);
			s2 := TPcopy(s, p + length(sub), 255);
		end;
		SplitRightAtStr := p > 0;
	end;
	
	function Match (pattern, name: Str255): Boolean;
		function M (p, n: integer): Boolean;
			var
				state: (searching, failed, success);
		begin
			state := searching;
			while state = searching do begin
				case ord(p <= length(pattern)) * 2 + ord(n <= length(name)) of
					0:  begin
						state := success;
					end;
					1:  begin
						state := failed;
					end;
					2:  begin
						state := success;
						while p <= length(pattern) do begin
							if pattern[p] <> '*' then begin
								state := failed;
								leave;
							end;
							p := p + 1;
						end;
					end;
					3:  begin
						case pattern[p] of
							'?':  begin
								p := p + 1;
								n := n + 1;
							end;
							'*':  begin
								p := p + 1;
								if p > length(pattern) then begin { short circuit the * at the end case }
									state := success;
								end else begin
									state := failed;
									while n <= length(name) do begin
										if M(p, n) then begin
											state := success;
											leave;
										end;
										n := n + 1;
									end;
								end;
							end;
							otherwise begin
								if name[n] <> pattern[p] then begin
									state := failed;
								end;
								n := n + 1;
								p := p + 1;
							end;
						end;
					end;
				end;
			end;
			M := state = success;
		end;
	begin
		UpperString(pattern, false);
		UpperString(name, false);
		Match := M(1, 1);
	end;

	procedure LimitStringLength (var s: string; len: integer; delimiter: char);
		var
			p: integer;
	begin
		Assert( len >= 1 );
		if length(s) > len then begin
			p := Pos(delimiter, s);
			if p <= 0 then begin
				p := length(s) div 2 + 1;
				s[p] := delimiter;
			end;
			while length(s) > len do begin
				if p > len div 2 + 1 then begin
					Delete(s, p - 1, 1);
					p := p - 1;
				end else begin
					Delete(s, p + 1, 1);
				end;
			end;
		end;
	end;

	function StringToOSType (const s: Str255): OSType;
		var
			t: OSType;
	begin
		if length(s) >= 4 then begin
			BlockMoveData(@s[1], @t, 4);
		end else begin
			t := OSType(0);
			BlockMoveData(@s[1], @t, length(s));
		end;
		StringToOSType := t;
	end;

	function OSTypeToString (t: OSType): Str255;
		var
			s:Str255;
	begin
		s:=concat(nul,nul,nul,nul);
		BlockMoveData(@t,@s[1],4);
		OSTypeToString:=s;
	end;

{$definec isdigit( ch ) (('0' <= ch) & (ch <= '9'))}

	function NaturalOrderCompareString( const s1, s2: string ): integer;
		label
			retry_decimal;
		var
			i1, i2: integer;
			result, minor_result: integer;
			ch1, ch2: char;
			uch1, uch2: char;
			n1, n2: longint;
			isdecimal1, isdecimal2: Boolean;
	begin
		i1 := 1;
		i2 := 1;
		result := 0;
		minor_result := 0;
		while result = 0 do begin
			if i1 > length( s1 ) then begin
				if i2 > length( s2 ) then begin
					leave;
				end else begin
					result := -1;
				end;
			end else if i2 > length( s2 ) then begin
				result := 1;
			end else begin
				ch1 := s1[i1];
				ch2 := s2[i2];
				if isdigit(ch1) & isdigit(ch2) then begin
					n1 := 0;
					while (i1 <= length(s1)) & isdigit(s1[i1]) do begin
						n1 := n1 * 10 + ord(s1[i1]) - 48;
						Inc(i1);
					end;
					n2 := 0;
					while (i2 <= length(s2)) & isdigit(s2[i2]) do begin
						n2 := n2 * 10 + ord(s2[i2]) - 48;
						Inc(i2);
					end;
					if n1 < n2 then begin
						result := -1;
					end else if n1 > n2 then begin
						result := 1;
					end else begin
retry_decimal:
						isdecimal1 := (i1 < length(s1)) & (s1[i1]='.') & isdigit(s1[i1+1]);
						isdecimal2 := (i2 < length(s2)) & (s2[i2]='.') & isdigit(s2[i2+1]);
						if isdecimal1 & isdecimal2 then begin
							Inc(i1);
							Inc(i2);
							while (result = 0) & (i1 <= length(s1)) & isdigit(s1[i1]) & (i2 <= length(s2)) & isdigit(s2[i1]) do begin
								if s1[i1] < s2[i2] then begin
									result := -1;
								end else if s1[i1] > s2[i2] then begin
									result := 1;
								end else begin
									Inc(i1);
									Inc(i2);
								end;
							end;
							if result = 0 then begin
								// fortunately, '.' < '0' so if there is a single decimal opposite a digit, the digit will win anyway
								goto retry_decimal;
							end;
						end else if isdecimal1 then begin
							result := 1;
						end else if isdecimal2 then begin
							result := -1;
						end else begin
							{ do nothing }
						end;
					end;
				end else begin
					uch1 := UpperCaseChar( ch1 );
					uch2 := UpperCaseChar( ch2 );
					if uch1 < uch2 then begin
						result := -1;
					end else if uch1 > uch2 then begin
						result := 1;
					end else begin
						if minor_result = 0 then begin
							if ch1 < ch2 then begin
								minor_result := -1;
							end else if ch1 > ch2 then begin
								minor_result := 1;
							end;
						end;
						Inc( i1 );
						Inc( i2 );
					end;
				end;
			end;
		end;
		if result = 0 then begin
			result := minor_result;
		end;
		NaturalOrderCompareString := result;
	end;

	function IsExtension (const name, ext: Str255): Boolean;
		var
			pn, pe: integer;
	begin
		if false then begin
			IsExtension := IUEqualString(TPcopy(name, length(name) - length(ext) + 1, 255), ext) = 0;
		end else begin
			IsExtension := false;
			if length(name) >= length(ext) then begin
				pn := length(name) - length(ext) + 1;
				pe := 1;
				while pe <= length(ext) do begin
					if UpperCaseChar(name[pn]) <> UpperCaseChar(ext[pe]) then begin
						leave;
					end;
					pn := pn + 1;
					pe := pe + 1;
				end;
				IsExtension := pe > length(ext);
			end;
		end;
	end;
	
	procedure DeleteExtension( var name: Str255; const ext: Str255 );
	begin
		if IsExtension( name, ext ) then begin
			Delete( name, length(name) - length(ext) + 1, length(ext) );
		end;
	end;

	function IsPrefix (const name, prefix: Str255): Boolean;
	begin
		IsPrefix := IUEqualString(TPcopy(name, 1, length(prefix)), prefix) = 0;
	end;

	procedure DeletePrefix( var name: Str255; const ext: Str255 );
	begin
		if IsPrefix( name, ext ) then begin
			Delete( name, 1, length(ext) );
		end;
	end;

	function IsAllInSet( const s: string; cs: CharSet ): Boolean;
		var
			good: Boolean;
			i: integer;
	begin
		good := true;
		for i := 1 to length(s) do begin
			if not s[i] in cs then begin
				good := false;
				leave;
			end;
		end;
		IsAllInSet := good;
	end;
	
end.
(*
	function UpperCaseChar (ch: char): char;
{$IFC not GENERATINGPOWERPC}
	inline
		$301F, $0C00, $0061, $6500, $000E, $0C00, $007B, $6400, $0006, $0400, $0020, $3E80;
{$ENDC}
	function IsDigit(ch:char):Boolean;
{$IFC not GENERATINGPOWERPC}
	inline
		$321F,$0C41,$0030,$5CC0,$6D08,$0C41,$0039,$6F02,$5FC0,$4400,$1E80;
{$ENDC}
	function IsLower(ch:char):Boolean;
{$IFC not GENERATINGPOWERPC}
	inline
		$321F,$0C41,$0061,$5CC0,$6D08,$0C41,$007A,$6F02,$5FC0,$4400,$1E80;
{$ENDC}
	function IsUpper(ch:char):Boolean;
{$IFC not GENERATINGPOWERPC}
	inline
		$321F,$0C41,$0041,$5CC0,$6D08,$0C41,$005A,$6F02,$5FC0,$4400,$1E80;
{$ENDC}
	function IsAlpha(ch:char):Boolean;
{$IFC not GENERATINGPOWERPC}
	inline
		$321F,$0C41,$0041,$5CC0,$6D16,$0C41,$005A,$6F10,$0C41,$0061,$5CC0,$6D08,$0C41,$007A,$6F02,$5FC0,$4400,$1E80;
{$ENDC}
*)