unit MyTrackIdle;

interface

	uses
		MacOS;

	function IdleSince: longint;  {TickCount at last no idle time}
	procedure StartupTrackIdle;

implementation

	uses
		MySystemGlobals, MyStartup;

	type
		keyLongMap = array[1..4] of longint;

	var
		lastmoved: longint;  { Last time the cursor was moved, used for idle timing }
		lastpos: Point;
		lastbutton: Boolean;
		lastkeymap: keyLongMap;

	procedure MyGetMouse (var pt: Point; var button: Boolean); { Handles not having quickdraw around }
		var
			event:EventRecord;
			dummy:boolean;
			mousestate:integer;
	begin
		dummy:=OSEventAvail(0,event);
		pt := event.where;
		if system85 then begin
			mousestate := LMGetMouseButtonState;
		end else begin
			mousestate := Ptr($172)^;
		end;
		button := band(mousestate, $080) = 0;
	end;

	procedure TrackIdle;
		var
			pt: Point;
			but: Boolean;
			km: keyLongMap;
	begin
		pt := lastpos;
		but := lastbutton;
		MyGetMouse( lastpos, lastbutton );
		if (abs(pt.h - lastpos.h) > 2) or (abs(pt.v - lastpos.v) > 2) or (but <> lastbutton) then begin
			lastmoved := TickCount;
		end else begin
			GetKeys(KeyMap(km));
			if (km[1] <> lastkeymap[1]) or (km[2] <> lastkeymap[2]) or (km[3] <> lastkeymap[3]) or (km[4] <> lastkeymap[4]) then begin
				lastmoved := TickCount;
				lastkeymap := km;
			end;
		end;
	end;

	function IdleSince: longint;  {TickCount at last no idle time}
	begin
		TrackIdle;
		IdleSince := lastmoved;
	end;

	function InitTrackIdle( var msg: integer ): OSStatus;
	begin
{$unused(msg)}
		MyGetMouse( lastpos, lastbutton );
		lastmoved := TickCount;
		GetKeys(KeyMap(lastkeymap));
		InitTrackIdle := noErr;
	end;

	procedure StartupTrackIdle;
	begin
		SetStartup( InitTrackIdle, TrackIdle, 0, nil );
	end;

end.